/*
  Mental Age
  by Tebe/Madteam & Danek
  
  last changes: 12.11.2003
  MADS version: 01.01.2005
*/

; $0300-$07ff sprity
; $0800-$27c0 zestawy znakow dla planszy z gra
; $1b88-...   obszar obrazu dla logosow poczatkowych
; $a300-$cfff sample
; $d800-$f37f rozpakowane tlo
; $f400-$fff9 muza MPT

; bar+$4e     liczba zyc

; zestaw znakow Hi-res
; ABCDEFGHIJKLMOPRSTUVWYZLZ.  I
; ostatnie I jest przesuniete do lewej strony

;- niektore z procedur np. noweTlo oraz przerwania powinny byc ponizej adresu $4000
;- poniewaz noweTlo przelancza banki i rozpakowuje tla, co troche trwa
;- jesli podczas przerwania bedzie skok pod $4000-$7fff to bedzie zwis

pmg	equ $0
clock 	equ $0f

clog1	equ $30			;kolory logosow
clog2	equ $f0
AdresTla equ $d800	;tutaj bedzie rozpakowana txtura

FntLog1	equ Fnt
FntLog2	equ FntLog1+$800
FntBW	equ FntLog2+$400
FntBw2	equ FntBw+$400
Cyfry	equ FntBw2+$400
Cyfry2	equ Cyfry+320

FntProd	equ Cyfry
bufPas	equ FntProd+$400	;tutaj przechowamy obraz, ktory oddamy po wyjsciu z password

FntGmOv	equ Fnt

MaxLevel equ $3c		;max komnat w grze

;msx	equ $f400
;smp	equ $a300
msx equ $a000		;gdzie jest rozpakowana muza z MPT

.local wybor_bankow 
 icl 'setup\setup.asm'
.endl

;---

Xms equ $e0

 opt h+
 org $0600

changeBank ldx #$ff
 lda xms+1
 cmp #$20
 beq *+5
 ldx xms+1

 stx $d301
 rts
 ini changeBank
 org $4000
tlo01 ins 'def\tlo01.def'
tlo02 ins 'def\tlo02.def'
tlo03 ins 'def\tlo03.def'
tlo04 ins 'def\tlo04.def'


 org $600		;wlacz OS
 lda #$ff
 sta $d301
 rts
 ini $600


 opt h+
;- depacker Fox-a
;-
 org $400
;-
.local dep400
 icl 'icl\inflmen.asm'	;tutaj skompilowany pod $400
.endl

;-
;- rozpakujemy MPT+sample
;-
 org $3000
;-
ini lda 20
 cmp 20
 beq *-2

	sei
	lda #0
	sta $d400
	sta 559
	sta $d40e
	lda #$fe
	sta $d301

;- depack

MsxPack	 equ $f400
msxTitle equ MsxPack
msxGame  equ MsxTitle+msx1-msx0
msxOver  equ MsxGame+msx2-msx1

	mwa #txt $f0
	mwa #AdresTla $f2
	jsr dep400
	
	ldx #12
	ldy #0
copy_	lda msx0,y
copy__	sta MsxPack,y
	iny
	bne copy_
	inc copy_+2
	inc copy__+2
	dex
	bne copy_

;	lda $d40b
;	bne *-3
	lda #$ff
	sta $d301
	lda #$40
	sta $d40e
	cli
	rts
	
txt	ins 'def\tlo00.def'
msx0	ins 'def\menta01.def'	;tempo=4
msx1	ins 'def\menta02.def'	;tempo=5
msx2	ins 'def\pain.def'	;tempo=9

;tlo01 - knight
;tlo02 - birds
;tlo03 - face
;tlo04 - sun

 org $2e2
 dta a(ini)


;- zestawy znakow wykorzystuja tylko 120 znakow (3x40=120)
;- dlatego od Zestaw+$3c0 jest wolny obszar (120*8=$3c0)
;- $0800
Fnt equ $0800

;- zmienne, w obszarze powyzej 120 znaku
E_0bc0 equ Fnt+7*$400+$3c0
E_0bc4 equ Fnt+7*$400+$3c4
E_0bc6 equ Fnt+7*$400+$3c6
E_0bca equ Fnt+7*$400+$3ca
E_0bcd equ Fnt+7*$400+$3cd
E_0bd0 equ Fnt+7*$400+$3d0
E_0bd1 equ Fnt+7*$400+$3d1
E_0bd6 equ Fnt+7*$400+$3d6
E_0bd9 equ Fnt+7*$400+$3d9
E_0bdc equ Fnt+7*$400+$3dc
E_0bdf equ Fnt+7*$400+$3df
E_0be2 equ Fnt+7*$400+$3e2
E_0be5 equ Fnt+7*$400+$3e5
E_0be8 equ Fnt+7*$400+$3e8
E_0bea equ Fnt+7*$400+$3ea
E_0bec equ Fnt+7*$400+$3ec
E_0bf1 equ Fnt+7*$400+$3f1
E_0bf4 equ Fnt+7*$400+$3f4
E_0bf7 equ Fnt+7*$400+$3f7
E_0bfa equ Fnt+7*$400+$3fa
E_0bfd equ Fnt+7*$400+$3fd

E_0fc0 equ Fnt+7*$400+$7c0
E_0fc3 equ Fnt+7*$400+$7c3
E_0fc6 equ Fnt+7*$400+$7c6
E_0fc9 equ Fnt+7*$400+$7c9
E_0fcc equ Fnt+7*$400+$7cc
E_0fcf equ Fnt+7*$400+$7cf
E_0fd2 equ Fnt+7*$400+$7d2
E_0fd5 equ Fnt+7*$400+$7d5
E_0fd7 equ Fnt+7*$400+$7d7
E_0fd9 equ Fnt+7*$400+$7d9
E_0fdd equ Fnt+7*$400+$7dd
E_0fe0 equ Fnt+7*$400+$7e0
E_0fe2 equ Fnt+7*$400+$7e2

;E_27c0 org *+$12	;bufory do ktorych przepisywana jest grafika klockow
;E_27d2 org *+$12
;E_27e4 org *+$1c

E_27c0 equ FntBar-$40	;bufory do ktorych przepisywana jest grafika klockow
E_27d2 equ FntBar-$2e
E_27e4 equ FntBar-$1c

Scr equ E_27c0-480-280		;$1b88, obszar na logosy w hi-res na fontach

;-------------------------
;- pod ten adres ladujemy
;-------------------------
 org $2800
;-------------------------
FntBar ins 'fnt\panel1.fnt',0,904	;$2800

;- maksymalny czas dla kazdego poziomu (komnaty), czyli 60 bajtow
;- aby odczytac trzeba zrobic eor #$75 i pomnozyc x10
MaxTime dta b($73,$70,$72,$7d,$6d,$65,$60,$64,$7c,$72,$7d,$72,$7d,$73,$7c,$64)
 dta b($7d,$7c,$7d,$7c,$61,$7c,$7d,$67,$61,$61,$64,$65,$7d,$66,$7c,$7d)
 dta b($50,$65,$56,$67,$61,$67,$7d,$66,$67,$57,$66,$64,$63,$67,$65,$60)
 dta b($67,$66,$60,$5c,$6d,$61,$67,$6d,$6c,$61,$55,$56)
 
;- tablica z adresem tla i kolorami
;- adres_tla,2kolorySprita,4kolory_obrazu
AdrTlo
; dta a(tlo00),b($98,$94),b($12,$14,$a7,$1a)	;snake
 dta a(tlo01),b($98,$94),b($24,$28,$fc,$e)	;sun
 dta a(tlo03),b($98,$94),b($f4,$f8,$fc,$0e)	;face
 dta a(tlo02),b($98,$94),b($84,$76,$0c,$0a)	;birds
 dta a(tlo04),b($98,$94),b($24,$28,$fc,$e)	;knight

 dta a(tlo01),b($98,$94),b($14,$16,$a8,$1a)	;snake
 dta b($00,$00,$00,$00)
 
; dta a(tlo00),b($98,$94)	;inne przykladowe kolory sprita (pajaczka)
; dta a(tlo00),b($98,$94)
; dta a(tlo00),b($a8,$a4)
; dta a(tlo00),b($38,$34)

;- jak najblizej poczatku strony
;- inaczej error
pole_gry org *+880		;$2be8	22linie po 40 bajtow

;- liczba zyc jest w Bar+$4e
BAR ins 'scr\oko1.scr',40,160	;$e220
    :40 brk


TabMsx00 dta b($b2,$bc,$f8,$10,$4e,$ab,$d0,$fe,$1c,$2b,$40,$e1,$ef,$30,$70,$3b)		;$2f58
 dta b($6e,$8e,$2f,$3d,$64,$05,$13,$3d,$4c,$50,$a3,$d6,$dd,$07,$31,$84)
 dta b($b7,$02,$05,$4b,$53,$60,$a6,$c3,$fb,$10,$30,$40,$83)

;---------------------------
;- KSZTALT Cyfr 0123456789
;- dla LEVEL XY
;---------------------------
;Cyfry	ins 'cyfryBW.dat'		;$4280, 4znaki po 8bajtow = 32 x 10 = 320
;Cyfry2	ins 'cyfryBW2.dat'
 
;- pozycja poczatkowa pajaczka (bohatera na spritach)
PosHero dta b($0f,$0f,$0f,$0f,$0e,$06,$0f,$0e,$0d,$0e,$0f,$0d,$0f,$0f,$0f,$0f)	;$43c0
 dta b($0e,$0f,$0f,$0f,$0f,$09,$0f,$0f,$0f,$0f,$07,$0f,$0f,$0f,$0f,$0f)
 dta b($0e,$0f,$04,$0f,$0f,$0f,$0f,$0f,$0e,$0f,$0f,$0e,$0f,$0d,$07,$0f)
 dta b($0f,$0e,$09,$0f,$0f,$09,$0f,$0e,$0f,$09,$06,$0f,$00,$00,$00,$00)

;- ekran logosa
log1	ins 'scr\m1.scr',0,7*40		;gorne logo mental
log2	ins 'scr\m2.scr',17*40,7*40	;dolne logo mental
;log_ovr	ins 'm3.scr',5*40,14*40		;game over

;- zestawy znakow logosa
;- MENTAL AGE Slavesa
;	org $3400
;FntLog1	ins 'm1.fnt',0,2048
;FntLog2	ins 'm2.fnt'

;- fonty Black&White
;- dla creditsow, adres musi byc $XX00
;	org $4000
;FntBW	ins 'fontyBW.dat'	
;FntBw2	ins 'fontyBW2.dat'	;$4400

;--------------------------
; KSZTALT SPRITA - KWADRAT
;--------------------------
E_b272 dta b($00,$00,$00,$00,$7f,$7f,$40,$40,$40,$40,$40,$40,$40,$40,$40,$40)
E_b282 dta b($40,$40,$40,$00,$7f,$ff,$00,$00)
E_b28a dta b($00,$00,$ff,$ff,$80,$80)
E_b290 dta b($80,$80,$80,$80,$80,$80,$80,$80,$80,$80)
E_b29a dta b($80,$80,$bf,$ff,$80,$00,$00,$00)
E_b2a2 dta b($00,$00,$03,$06,$0c,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06,$06)
E_b2b2 dta b($06,$06,$06,$06,$0c,$0c,$00,$00)

 
TECZA dta b($11,$11,$22,$22,$33,$33,$44,$45,$55,$66,$67,$77,$88,$99,$aa,$bb)		;$b2ba
 dta b($cc,$dd,$ee,$ff,$ff,$ee,$dd,$cc,$bb,$aa,$99,$88,$77,$76,$66,$55)
 dta b($54,$44,$33,$33,$22,$22,$11,$11)


;- tutaj koniecznie adres podzielny calkowicie przez 256
;- DLI musza miescic sie na 1 stronie pamieci
;- lda $80 itp jako docyklowanie

dli4
; sta $d40a
 :4 lda $80
md00 lda >FntBw
 sta $d409
k709 lda #$0f		;kolor2 - jasnosc
 sta $d017
k710 lda #$00		;kolor3 - kolor
 sta $d018
 lda <dli4_
 sta DliVec+1
 pla
 rti
 
dli4_
; sta $d40a
 :4 lda $80
pozY lda tabFnt		;tutaj adres jak najblizej poczatku strony
 sta $d409
 inc pozY+1
 lda pozY+1
 cmp <tabFnt+7
 bne skp
 lda <_log2
 sta DliVec+1
skp pla
 rti
tabFnt dta h(FntBw+$400,FntBw,FntBw+$400,FntBw,FntBw+$400,FntBw,FntBw+$400)
 
;_log1_
dli2
; sta $d40a		;drugi zestaw
 :4 lda $80
 lda >FntLog1+$400
 sta $d409
 lda <dli4
 sta DliVec+1
 pla
 rti
;-
_log2
; sta $d40a		;logos AGE
 :5 lda $80
 asl @
 lda >FntLog2	;1 zestaw
 sta $d409
kol01 lda #0 $f6
 sta $d016
 lda #0	$f8
 sta $d017
 lda #0	$fc
 sta $d018
 lda #0	$fe
 sta $d019
 lda <tabFnt
 sta pozY+1
 pla
 rti
 
;--

dligo0 sta $d40a
 lda >FntGmOv+$400
 sta $d409
 lda <dligo1
 sta DliVec+1
 pla
 rti

dligo1 sta $d40a
 lda >FntGmOv+$800
 sta $d409
 pla
 rti
 
;--------------
;- grafiki tla
;--------------
;tlo00
;ins 'tlo00.def'		;$4800-$637f
;tlo01
;ins 'tlo01.def'		;$6380-$7eff
;tlo02
;ins 'tlo02.def'		;$7f00-$9a7f

 
E_9a80 ldx $91			;subroutine
 ldy #$00
E_9a84 lda ($94),y
 sta $30,x
 inx
 iny
 cpy #$08
 bcc E_9a84
 txa
 clc
 adc #$08
 tax
E_9a93 lda ($94),y
 sta $30,x
 inx
 iny
 cpy #$10
 bcc E_9a93
 ldx $91
E_9a9f lda ($94),y
 sta $50,x
 inx
 iny
E_9aa5 cpy #$18
E_9aa7 bcc E_9a9f
 bit $86
 bvs E_9ac8
 lda $94
 sec
 sbc #$08
 sta $96
 lda $95
 sbc #$00
 sta $97
E_9aba ldx $91
 ldy #$00
E_9abe lda ($96),y
 sta $20,x
 inx
 iny
 cpy #$08
 bcc E_9abe
E_9ac8 rts
E_9ac9 ldy #$00
 jsr E_9ad0
 ldy #$08
E_9ad0 lda ($94),y
 sta $10,x
 inx
 iny
 lda ($94),y
 sta $10,x
E_9ada inx
 rts
E_9adc lda $94
 clc
 adc #$06
 sta $94
 bcc E_9ae7
 inc $95
E_9ae7 rts
E_9ae8 lda ($94),y
 sta $10
 lda ($9a),y
 sta $18
 iny
 lda ($94),y
 sta $11
 lda ($9a),y
 sta $19
 rts
gos00 jsr E_9adc		;$9afa - ruch klocka w lewo
 jsr E_9bd3
 bit $86
 bmi E_9b0a
 lda $8a
 and #$10
 beq E_9b0e
E_9b0a lda #$80
 sta $9c
E_9b0e dec $80
 jsr E_9bd3
E_9b13 ldy #$00
 jsr E_9ae8
 lda #$ff
 sta $8e
 lda #$fc
 sta $8f
 lda #$40
 jsr E_9fb3
 lda #$00
 sta $9c
 sta $90
 jsr E_9fb3
 lda #$00
 jsr E_9fb3
 lda #$ff
 sta $8f
 lda #$80
 jsr E_9fb3
 dec $93		;zmniejsz pozycje pozioma przesuwanego klocka (lewo)
 beq E_9b61
 lda $94
 sec
 sbc #$08
 sta $94
 bcs E_9b4b
 dec $95
E_9b4b lda $9a
 sec
 sbc #$08
 sta $9a
 bcs E_9b56
 dec $9b
E_9b56 jsr E_b014
 lda $93
 and #$01
 bne E_9b13
 beq E_9b0e
E_9b61 jsr E_a446
 lda $92
E_9b66 ldx $80
 sta $0200,x
 jsr E_a48a
 lda #$80
 sta $8c
 jsr E_a5d8
 jmp E_b35f
E_9b78 sty $91
 lda $8e
 eor #$ff
E_9b7e sta $8d
 bit $87
 bmi E_9ba8
 bit $88
 bvs E_9b95
 lda $10
 and $8e
 sta ($94),y
 lda $11
 and $8e
 iny
 sta ($94),y
E_9b95 bit $89
 bvs E_9ba8
 txa
 tay
 lda $14
 and $8d
 sta ($94),y
 iny
 lda $15
 and $8d
 sta ($94),y
E_9ba8 bit $87
 bvs E_9bd2
 bit $88
E_9bae bmi E_9bbf
 ldy $91
 lda $18
 and $8e
 sta ($9a),y
 iny
 lda $19
 and $8e
 sta ($9a),y
E_9bbf bit $89
 bmi E_9bd2
 txa
 tay
 lda $1c
 and $8d
 sta ($9a),y
 iny
 lda $1d
 and $8d
 sta ($9a),y
E_9bd2 rts
E_9bd3 lda #$00
 pha
 lda $80
 sec
 sbc #$14
 tax
Testowanie lda $0200,x
 beq E_9be5
 pla
 ora #$40
 pha
E_9be5 lda $80
 clc
 adc #$14
 tax
 lda $0200,x
 beq E_9bf4
 pla
 ora #$80
 pha
E_9bf4 lda $88
E_9bf6 sta $89
 pla
 sta $88
E_9bfb rts
E_9bfc stx $8d
 pha
 tay
 asl @
 tax
 lda #$08
 sta $91
E_9c06 lda $20,x
 and $8d
 sta ($96),y
 inx
 iny
 dec $91
 bne E_9c06
 pla
 tay
 lda #$08
 sta $91
E_9c18 lda $20,x
 and $8d
 sta ($98),y
 inx
 iny
 dec $91
 bne E_9c18
 rts

;-----------------------
; Antic0 - Title Screen $e385
;-----------------------
ant0 dta b($70)
 dta b($44),a(scr-280),b(4,4,4+$80,4,4,4),b(1)
modAnt dta a(mod)
 
;-----------------------
;- Antic1 - Game Screen $af99
;-----------------------
ant1 dta d'pp',b($a0),b($4f),a(tecza)
 dta b($30)
 dta b($44),a(pole_gry)		;ekran gry
 dta b($04,$84,$04,$04,$84,$04,$04)
 dta b($84,$04,$04,$84,$04)
 dta b($04,$84,$04,$04,$84,$04,$04,$84,$04,$0,$a0)
 dta b($4f),a(tecza)		;kolorowy bar w 16odcieniach (tryb 9OS)
 dta b($10)
 dta b($44)
 dta a(bar)		;bar ze wskaznikami gry, czas, liczba zyc itd
 dta b(4,$84,4)
 dta b($41),a(ant1)
 
;------------------------
;- Antic2 - Level Screen $e570
;------------------------
ant2 dta b($70,$00)
 dta d'ppp',b($70+$80),d'pppp'
 dta b($10+$80)
 dta b($42),a(scr),b(2+$80,$2+$80),b($10)
 dta b($2,2+$80,$2+$80),b($10)
 dta b($2,2+$80,$2+$80),b($10)
 dta b($2,2+$80,$2+$80)
 dta b($10+$80)
 dta b($41),a(ant2)

;--------------------------
;- Antic3 - GameOver Screen 
;--------------------------
ant3 dta d'ppppppp',b($30)
 dta b($44),a(FntGmOv+3072)
 dta b($04,$04,$04,$04,$04,$04+$80,$04)
 dta b($04,$04,$04,$04,$04+$80,$04)
 dta b($41),a(ant3)

mod dta b($10+$80,$10)
 dta b($2,2+$80,$2+$80),b($10)
 dta b($2,2+$80,$2+$80),b($10)
 dta b($2,2+$80,$2+$80),b($10)
 dta b($2,2+$80,$2+$80)
 dta b($10+$80,$10)
 dta b(4,4,4,4,4,4,4)
 dta b($41),a(ant0)

ant0_ dta b($10+$80,$10,$10,$10)
 dta b($2,2+$80,$2+$80)
 dta b($2,2+$80,$2+$80)
 dta b($2,2+$80,$2+$80)
 dta b($2,2+$80,$2+$80)
 dta b($10+$80,$10)
; dta b(4,4,4,4,4,4,4)
 dta b($41),a(ant0)

;--------------

dli1 lda $a4		;tutaj >adres fontow
 clc
 adc #$04
 sta $a4
E_aa43 sta $d40a
 sta $d409
 cmp #$24
 beq E_aa4f
 pla
 rti
E_aa4f mwa #dli3 DliVec+1
* lda #$03
* sta DliVec+1
* lda #$b3
* sta DliVec+2
 pla
 rti

tecza1
dli0 lda #$60		;$b2e2
 sta $d40a		;kolor teczowego baru
 sta $d01a
E_b2ea lda #$31
 sta $d40a
 sta $d01b
 lda #$00		;czarne tlo planszy z gra
 sta $d01a
 mwa #dli1 DliVec+1
* lda #$3c
* sta DliVec+1
* lda #$aa
* sta DliVec+2
 pla
 rti
 
dli3 lda #$71		;$b303
 sta $d40a
 sta $d01b
tecza2 lda #$60		;kolorowa tecza
 sta $d01a
 lda #$00
 sta $d40a
 sta $d01a
 lda #$31
 sta $d01b
int_ lda >BarInt	;FntBar
 eor #$38
 sta int_+1
 sta $d409

Cbar0 lda #$04		;kolory Panelu
 sta $d016
Cbar1 lda #$06
 sta $d017
Cbar2 lda #$08
 sta $d018
Cbar3 lda #$0c
 sta $d019

 mwa #dli3_ DliVec+1
 pla
 rti

dli3_ sta $d40a
int2_ lda >BarInt+$400	;FntBar
 eor #$38
 sta int2_+1
 sta $d409

 pla
 rti
 
;---------
;- NMI
;---------
NMI pha
 lda $d40f
 bpl Vbl
DliVec jmp dli2

Vbl txa
 pha
 tya
 pha

FntBase lda >FntBW
 sta $a4
 sta $d409

 inc clock
* jsr E_3d08
 lda $d010
 and #$01
 sta $00
gtia lda #$00
 sta $d01b
dmactl lda #$21
 sta $d400
dli_LMS lda <dli2
 sta DliVec+1
dli_MSB lda >dli2
 sta DliVec+2
 
 lda #$00
 sta $d01a
 ldx #$07
E_aa96 lda $f0,x
 sta $d012,x
 dex
 bpl E_aa96

 jsr mpt
; jsr Mruganie

VBLjmp jmp Zegar
 
Zegar dec $a9
 bne nmiQ
 lda #$32
E_aaa4 sta $a9
E_aaa6 jsr E_ad06
E_aaa9 beq nmiQ
E_aaab ldx #5		;ZEGAR
E_aaad jsr Zmniejsz
E_aab0 bcs nmiQ
 jsr Zmniejsz
 bcs nmiQ
E_aab7 jsr Zmniejsz

nmiQ lda dmactl+1
 sta $d400
 pla
 tay
 pla
 tax
dliQ pla
IRQ rti

Jump jsr rtsQ
VBLv jmp $ffff

;--------------

depack icl 'icl\inflmen.asm'

;--------------

;tabAnima dta b(10+$80,10+$80,12+$80,14+$80,16+$80,14+$80,12+$80,10+$80)

;Mruganie lda #0
; beq anT
;czekaj lda #0
; inc czekaj+1
; cmp #16
; bne anQ
; lda #0
; sta czekaj+1

; ldy mruganie+1
; ldx tabAnima,y
; stx bar+26+40
; inx
; stx bar+27+40

; inc mruganie+1
; lda mruganie+1
; cmp #7
; bne anQ
; lda #0
; sta mruganie+1
;anT lda clock
; cmp #200
; bne anQ
; inc mruganie+1
;anQ rts 

;---

noweTlo lda xms+1
 cmp #$20
 beq tloQ
 and #$fe
 sta $d301
 mwa AdrTlo,y $f0	;rozpakuj txture pod $d800
 mwa #AdresTla $f2
 jsr depack

 lda #$fe
 sta $d301
 rts
tloQ lda #4*8
 sta losY+1
rtsQ rts

;---

Zmniejsz ldy bar+$28,x	;zmniejsz o 1 wartosc na ekranie
 cpy #$80
 beq E_acaf		;zmniejsza 4 znaki
 dec bar+$28,x		;w rej X ofset do zmniejszanej wartosci w panelu
; dec bar+$29,x
; dec bar+$50,x
; dec bar+$51,x
 sec
 rts

E_acaf lda #$89		;wpisuje 9 i leci dalej
E_acb1 sta bar+$28,x
 tay
 clc
; lda #$0a
;E_acb8 sta bar+$29,x    ;zmniejsz czas o 10
; dec bar+$27,x

;E_acbb adc #$0a
; sta bar+$50,x
; adc #$0a
; sta bar+$51,x
; :$02 dex
 dex
 tya
 rts

E_acc9 lda bar+$28,x
 cmp #$89
 beq E_acdc
 inc bar+$28,x		;zwiekszamy liczbe kluczy
; inc bar+$29,x
; inc bar+$50,x
; inc bar+$51,x
E_acdc rts

E_acdd lda $d20f
 and #$04
 bne E_acf2
 lda $d209		;test klawisza ESC
 cmp #$1c
 bne E_acf2
E_aceb pla
 :$03 pla
 jmp E_af50
E_acf2 lda $d01f
 lsr @
 bcs E_acff
 :$04 pla
 jmp E_af5a
E_acff jsr E_ad06
 bne E_acdc
 beq E_aceb

E_ad06 lda bar+$28+3	;test licznika zegara
 ora bar+$28+4
 ora bar+$28+5
 and #$7f

; lda bar+$31
; ora bar+$33
; ora bar+$35
 rts
 
E_ad10 lda #$00
 tax
E_ad13 sta pmg+$300,x		;czysci sprity
 sta pmg+$400,x
 sta pmg+$500,x
 sta pmg+$600,x
 sta pmg+$700,x
 inx
 bne E_ad13
 mwa #pole_gry $94
; lda #$e8
; sta $94
; lda #$2b
; sta $95
 ldy #$00
E_ad2f lda ($94),y
 and #$7f
 sta ($94),y
 inc $94
 bne E_ad3b
 inc $95
E_ad3b lda $94
 cmp #$58
 bne E_ad2f
 lda $95
 cmp #$2f
 bne E_ad2f
 lda #$07
 sta $93
 lda $78
 sta $94
 lda $79
 sta $95
 lda #$00
 sta $96
 lda #$08
E_ad59 sta $97
E_ad5b lda #$03
 sta $91
 ldy #$00
E_ad61 lda ($94),y
 sta ($96),y
 iny
 bne E_ad61
 inc $95
 inc $97
 dec $91
 bne E_ad61
E_ad70 lda ($94),y
 sta ($96),y
 iny
 cpy #$c0
 bcc E_ad70
 inc $97
 lda $94
 clc
 adc #$c0
 sta $94
 bcc E_ad86
 inc $95
E_ad86 dec $93
 bne E_ad5b
 ldy #$00
E_ad8c lda ($94),y
 sta ($96),y
 iny
 bne E_ad8c
 inc $95
E_ad95 inc $97
 ldy #$3f
E_ad99 lda ($94),y
 sta ($96),y
 dey
 bpl E_ad99
 rts
E_ada1 lda #$00
 sta $92
 sta $a5
 lda #$ff
E_ada9 sta $a6
E_adab inc $a6
 lda $a6
 cmp #$0b
 bcc E_adb6
 jmp E_ae8e
E_adb6 clc
 adc #$01
 :$02 asl @
E_adbb tay
 dey
 ldx #$03
E_adbf lda E_aac6,y
 sta $96,x
 dey
 dex
 bpl E_adbf
E_adc8 ldx $92
 lda $0200,x
 beq E_adf8
 jsr E_a48a
E_add2 inc $92
 lda $96
 clc
 adc #$10
 sta $96
 bcc E_addf
 inc $97
E_addf lda $98
 clc
 adc #$10
 sta $98
 bcc E_adea
 inc $99
E_adea inc $a5
 lda $a5
 cmp #$14
 bcc E_adc8
 lda #$00
 sta $a5
 beq E_adab
E_adf8 lda $96
 clc
 adc #$08
 sta $94
E_adff lda $97
 adc #$00
 sta $95
 lda $98
 clc
 adc #$08
 sta $9a
 lda $99
 adc #$00
 sta $9b
 ldx $a5
 beq E_ae2f
 ldy $92
 dey
 lda $0200,y
 beq E_ae2f
 ldy #$07
E_ae20 lda ($94),y
 and #$3f
 sta ($94),y
 lda ($9a),y
 and #$3f
 sta ($9a),y
 dey
 bpl E_ae20
E_ae2f cpx #$13
 beq E_ae4e
 ldy $92
 iny
 lda $0200,y
 beq E_ae4e
 ldy #$0f
E_ae3d lda ($94),y
 and #$fc
 sta ($94),y
 lda ($9a),y
 and #$fc
 sta ($9a),y
 dey
 cpy #$08
 bcs E_ae3d
E_ae4e ldx $a6
 beq E_ae6c
 lda $92
 sec
 sbc #$14
 tay
 lda $0200,y
 beq E_ae6c
 lda #$00
 tay
 sta ($94),y
 iny
 sta ($94),y
 ldy #$08
 sta ($94),y
 iny
 sta ($94),y
E_ae6c cpx #$0a
 beq E_ae8b
 lda $92
 clc
 adc #$14
 tay
 lda $0200,y
 beq E_ae8b
 lda #$00
 ldy #$06
 sta ($9a),y
 iny
 sta ($9a),y
 ldy #$0e
 sta ($9a),y
 iny
E_ae89 sta ($9a),y
E_ae8b jmp E_add2
E_ae8e mwa #pole_gry $94
; lda #$e8
; sta $94
; lda #$2b
; sta $95
 ldx #$00
E_ae98 lda #$14
 sta $91
E_ae9c lda $0200,x
 beq E_aebf
 ldy #$00
 lda ($94),y
 ora #$80
 sta ($94),y
 iny
E_aeaa lda ($94),y
 ora #$80
E_aeae sta ($94),y
 ldy #$28
 lda ($94),y
 ora #$80
 sta ($94),y
 iny
E_aeb9 lda ($94),y
E_aebb ora #$80
E_aebd sta ($94),y
E_aebf inx
 cpx #$dc
 beq E_aee0
 lda $94
 clc
 adc #$02
 sta $94
E_aecb bcc E_aecf
 inc $95
E_aecf dec $91
 bne E_ae9c
 lda $94
 clc
 adc #$28
 sta $94
 bcc E_ae98
 inc $95
 bcs E_ae98
E_aee0 rts
E_aee1 lda #$00
 sta $a7
 sta $aa
 sta $a8
E_aee9 sta $ac
E_aeeb lda #$31
E_aeed sta E_b2ea+1
 jsr E_9f4e
 lda #$32
 sta $a9
 jsr E_ad10
E_aefa jsr E_ada1
 lda #$00
 sta $81
 sta $82
 sta $9e
 sta $9f
 ldx #$00
E_af09 lda $0200,x
 cmp #$08
 beq E_af21
 inx
 inc $81
 lda $81
 cmp #$14
 bcc E_af09
 lda #$00
 sta $81
 inc $82
 bne E_af09
E_af21 stx $80
 lda $81
 :$03 asl @
 clc
 adc #$30
 sta $83
 sta $d000
 sta $d001
 lda $82
 :$04 asl @
 clc
 adc #$1e
E_af3c sta $84
 lda #$03
 sta $85
 lda #$00
 sta $8b
 lda #$80
 sta $8c
 
 jsr E_b333
 jmp E_a57a
E_af50 ldx #17		;zmniejsz liczbe zyc
Lives jsr Zmniejsz
 lda Bar+40+17		;liczba zyc w panelu
 and #$7f
 bne E_af67
E_af5a ldy #$0f		;wygas obraz, skonczyly Ci sie zycia
E_af5c jsr E_e34c
 dec $01
 jsr PanelOff
 dey
 bne E_af5c

 jsr ClrSprite		;GAME OVER
 sta dmactl+1
 jsr WyciszMsx
; lda #$60		;wyciszmy msxGame
; sta mpt
; jsr msxStop
 jsr wait

 jsr SetMsxOver

 mwa #fnt01 $f0		;rozpakuj FNT01
 mwa #FntGmOv $f2
 jsr depack

 jsr setZero

 lda >FntGmOv
 sta FntBase+1
 jsr wait
 lda <dligo0
 sta dli_LMS+1
 lda >dligo0
 sta dli_MSB+1
 lda #$22
 sta dmactl+1
 mwa #ant3 $d402
 jsr wait
 
 jsr nulIns
 jmp over

;--
E_af67 jsr E_e534	;kontynuj, zacznij level od nowa
 jmp E_a620
;-- 

over jsr ciemno
; lda #0
; sta clock

cze
 jsr wait
 ldy #3
czeX lda adrl,y	;test instrumentu $d
 cmp #$2a
 bne czN
 lda adrh,y
 cmp #$a4
 beq over_2
czN dey
 bpl czeX

; cmp #$3
; beq over_2
; dey
; bpl czeX

czeQ jsr ReadKey
 bcc cze
QQQ jsr ciemno
 jsr WyciszMsx
 jmp EkranPocz

over_2 lda #0
 sta adrl,y
 sta adrh,y
 jsr jasno
 ldx #$40
wwai jsr ReadKey
 bcs QQQ
 jsr wait
 dex
 bne wwai
 jmp over

;------------
SetMsxOver mwa #msxOver $f0	;ustaw msxOver
 mwa #msx-6 $f2
 jsr depack
 jsr mpt+3
; lda #$4c
; sta mpt
 jsr SetMsx
 rts
;------------

Wstep lda #0
 bne ws_
 lda #129
 sta Wstep+1
ws_ dec Wstep+1
 bne sk05
 lda #0
 sta Wstep+1
 sta Wstep_+1
 mwa #Wstep_ VBLv+1
sk05 jmp nmiQ


Wstep_ lda #0
 bne wsX_
 lda #31
 sta Wstep_+1
wsX_ lsr @
 sta k709+1
 dec Wstep_+1
 bne sk05X
 lda #0
 sta Wstep_+1
 mwa #Wstep2 VBLv+1
sk05X jmp nmiQ



Wstep2 lda #0		;opoznienie
 bne ws2_

 sta k709+1

 lda #$4c		;startuj player wpisujac rozkaz JMP
 sta mpt
 sta playMusic+1

 lda >FntBW+$400
 sta TabFnt
 ldy #6
ws lda >FntBW+$400
 sta TabFnt,y
 lda >FntBW
 sta TabFnt-1,y
 dey
 dey
 bne ws
; lda >FntBW
 sta md00+1

 mwa #PokazLogoMentala Petla+1
 
 mwa #mod modAnt
 lda #$22
 sta dmactl+1
 
 lda #100
 sta Wstep2+1
ws2_
; jsr DelayKey
 dec Wstep2+1
 bne sk06
 ldy #0
 sty Wstep2+1
 iny
 sty $93
 mwa #GlownaPetla VBLv+1
sk06 jmp nmiQ


GlownaPetla lda #0
 bne E_9cf1
 mwa #napisy $96	;pokazuje napisy ma poczatku - creditsy
; lda <napisy
; sta $96
; lda >napisy
; sta $97
 lda #$04		;ile ekranow pokazywac (default=4)
 sta $93
E_9cec jsr ShowTxt+3	;omin Wait w procedurze ShowTxt
 lda #$0f
 sta GlownaPetla+1
E_9cf1 inc k709+1	;rozjasniamy
 jsr DelayKey
 dec GlownaPetla+1
 bne sk00
 lda #$f
 sta k709+1
 lda #0
 sta GlownaPetla+1
 mwa #Faza2 VBLv+1
sk00 jmp nmiQ
 
 
Faza2 lda #0
 bne E_9cfc

 lda #$e0	$c8		;opuznienie
 sta Faza2+1
E_9cfc jsr DelayKey
 dec Faza2+1
 bne sk01
 lda #0
 sta Faza2+1
 mwa #Faza3 VBLv+1
sk01 jmp nmiQ
 
 
Faza3 lda #0
 bne E_9d04 
 
 lda #$0f
 sta Faza3+1
E_9d04 dec k709+1	;sciemniamy
 jsr DelayKey
 dec Faza3+1
 bne sk02
 lda #0
 sta Faza3+1
 sta k709+1
 dec $93		;nastepy ekran
 bne sk03
 jmp sk_		;od poczatku
sk03 lda #$f
 sta GlownaPetla+1
 jsr ShowTxt+3
sk_ mwa #GlownaPetla VBLv+1
sk02 jmp nmiQ

OffVbl mwa #zegar VBLjmp+1
 lda k709+1
 sta ko9+1
 lda $93
 sta b93+1
 lda $96
 sta b96+1
 lda $97
 sta b97+1
 ldy #0
of_ lda scr,y
 sta bufPas,y
 lda scr+$100,y
 sta bufPas+$100,y
 iny
 bne of_
 rts

; lda #7
; jsr mpt
 
msxStop lda #$60	;wpisz RTS
 sta mpt
 ldy #8			;muza stop
 lda #0
sil sta $d200,y
 sta $d210,y
 dey
 bpl sil
 lda #3
 sta $d20f
 rts


DelayKey jsr ReadKey
 bcc E_9d1d
 :2 pla
 mwa #PlayGame Petla+1
; mwa #nmiQ Vblv+1 
 jsr OffVbl
 jmp nmiQ
E_9d1d cmp #$0c
 bne _rts
 :2 pla
 jsr OffVbl
 mwa #GetPass Petla+1	;wpisanie PASSWORD
 jmp nmiQ
_rts rts	jmp Wait		;wlasciwa GRA


PlayGame ldy #$0f
FadeOff jsr E_e34c
 lda k709+1
 beq E_9d36
 dec k709+1
E_9d36 dec $01
 dey
 bne FadeOff
 sty $9d 
 
 jsr Wait 
 lda kol01+1
 beq skip
 ldx <kol01+1
 ldy >kol01+1
 lda #$f0
 jsr FadeOut
 
skip lda #$83
 sta bar+40+17
; mwa #$0d03 bar+$4e		;ustawiamy zycia na wartosc 3
; mwa #$2117 bar+$4e+$28	;lives=3

 lda #0
 sta $d400
 sta dmactl+1
 jsr WyciszMsx
; lda #$60		;wyciszmy msxTitle
; sta mpt
; jsr msxStop

 mwa #msxGame $f0	;ustaw msxGame
 mwa #msx-6 $f2
 jsr depack
 jsr mpt+3
 jsr SetMsx
; lda #$4c
; sta mpt

 jmp LevelStart
 
;--
Kol_709 lda k709+1
 beq ko9
 dec k709+1
 jsr wait
 jmp Kol_709
ko9 lda #0
 sta k709+1

BufPasMove ldy #0
of2_ lda bufPas,y
 sta scr,y
 lda bufPas-32+$100,y
 sta scr-32+$100,y
 iny
 bne of2_
 rts
;--
 
GetPass ldx k709+1	;PASSWORD
 beq JuzZero
E_9d43 dec k709+1
 jsr Wait
 dex
 bne E_9d43
JuzZero ldx #$05
 lda #$1b		;kropki w miejsce hasla
E_9d50 sta pass,x
 dex
 bpl E_9d50
 inx
 stx $a6
 mwa #EnterPassword $96
; lda <EnterPassword
; sta $96
; lda >EnterPassword
; sta $97
 jsr ShowTxt 
E_9d64 lda <EnterPassword
E_9d66 sta $96
 lda >EnterPassword
 sta $97
 jsr E_e3d3
 lda #$0f
 sta k709+1
E_9d74 jsr ReadKey
E_9d77 cmp #$0c		;czy Return (wyjscie z wpisywania password)
 bne NextChar
 ldx #$05		;sprawdz haslo
E_9d7d lda Pass,x
 cmp TstPass,x
 bne E_9d94
 dex
 bpl E_9d7d
 lda #$00
 sta k710+1
 lda #$ad		;niesmiertelnosc
 sta Lives
 bne GetPass
 
E_9d94
; lda #$00		;zly password
; sta k709+1
 jsr Kol_709

 jsr Wait
b93 lda #0
 sta $93
b96 lda #0
 sta $96
b97 lda #0
 sta $97
; mwa #Faza3 VBLv+1				Wstep2 VBLv+1
 jmp PassExit
 
NextChar cmp #$34		;wpisuj haslo
 bne E_9db1
E_9da3 ldx $a6
 beq E_9d74
 dex
 dec $a6
 lda #$1b
 sta pass,x
 bne E_9d64
E_9db1 ldy $a6
 cpy #$06
 beq E_9d74
 ldx #$17
E_9db9 cmp Alfabet,x		;w password wpisuj tylko znaki z listy Alfabet
 beq E_9dc3
 dex
 bpl E_9db9
 bmi E_9d74
E_9dc3 inx
 txa
 sta pass,y
 inc $a6
 bne E_9d64
 
LevelStart lda #MaxLevel-1	;LevelStart
;  lda #7-1
 sta $9d
;  jmp NewLevel
 lda #$03
 ldx #$9b
 jsr E_acb1
 mwa #Testowanie $96
; lda <Testowanie
; sta $96
; lda >Testowanie
; sta $97
E_9ddf ldy #$05		;skomplikowane obliczenia numeru poziomu (6 znakow)
E_9de1 lda ($96),y
 eor TabMsx00,y
E_9de6 cmp #$18
 bcc E_9dee
 sbc #$18
 bcs E_9de6
E_9dee adc #$01
 cmp Pass,y		;testujemy z wyliczonym haslem
 beq E_9e06
E_9df5 lda $96		;rozszyfrowujemy
 sec
 sbc #$06
 sta $96
 bcs E_9e00
 dec $97
E_9e00 dec $9d		;teraz go zmniejszamy
 bne E_9ddf		;i sprawdzamy czy =0
 beq NewLevel		;jesli rowny to nowe TLO
E_9e06 dey
 bpl E_9de1
 
;-
;- NEW Level
;-
NewLevel
 lda #$00		;zaczynamy level z nowym TLEM
 sta dmactl+1
 lda #$fe
 sta Level+9		;najpierw modyfikacja napisu level xy
 lda $9d
 tax
 sec
E_9e17 sbc #$04		;jak przejdziesz 5 poziomow to pokaz password !!!
 beq E_9e22
 bcs E_9e17
 inc Level+9
 bne E_9e56

E_9e22 dex
 txa
 asl @
 sta $96
 asl @
 adc $96
 sta $96
 lda #$00
 adc #$00
 sta $97
 lda $96
 clc
 adc <E_9a80
 sta $96
 lda $97
 adc >E_9a80
 sta $97
 ldy #$05
E_9e41 lda ($96),y
 eor TabMsx00,y
E_9e46 cmp #$18
 bcc E_9e4e
 sbc #$18
 bcs E_9e46
E_9e4e adc #$01
 sta PutPass,y
 dey
 bpl E_9e41
E_9e56 lda #$00
 sta Level+8		;modyfikacja
 lda $9d
 clc
 adc #$01
 sta $a5
 cmp #$0a
 bcc E_9e7a		;czy level<10 jesli tak to tylko jedna cyfra
E_9e66 ldx #$1d
 stx Level+8
 ldx #$00
 stx $a5
E_9e6f inc $a5
 sec
 sbc #$0a
 cmp #$0a
 bcs E_9e6f
 sta $a6
E_9e7a mwa #fnt02 $f0
 mwa #FntBW $f2
 jsr depack
 
 lda $a5
 ldx #$1f
 jsr MoveCyf
 lda $a6
 ldx #$3f
 jsr MoveCyf
; lda $9d		;wybor Tla
; and #$18
* lda #3*8
; tay

 lda #10
 sta jeszczeRaz+1	;ilosc powtorzen
jeszczeRaz lda #0
 beq losQ
 dec jeszczeRaz+1
 lda $d20a
; nop
; eor $d20a
 and #%00011000
 tay
oldTlo cmp #$ff
 beq jeszczeRaz
losQ sty losY+1
 sta oldTlo+1

 jsr noweTlo

 mwa #AdresTla $78
; lda AdrTlo,y		;adres tla
; sta $78
; lda AdrTlo+1,y
; sta $79

losY ldy #0
 ldx #$00
E_9e99 lda AdrTlo+2,y
 sta $70,x
 lda AdrTlo+4,y
 sta $74,x
 inx
 iny
 cpx #$04
 bcc E_9e99
 
 ldy losY+1		;kolor dla teczy
 lda AdrTlo+4,y
 and #$f0
 sta tecza1+1
 sta tecza2+1

 and #$f0		;kolor panela
; add #$30
 ora #4
 sta Cbar0+1

; lda AdrTlo+5,y
 and #$f0
; add #$20
 ora #8
 sta Cbar1+1

 lda AdrTlo+5,y
 and #$f0
; add #$10
 ora #$a
 sta Cbar2+1

; and #$f0
; ora #$c
 lda #$e
 sta Cbar3+1

 jsr setTecza
 
 mwa #klocki+$1e0 AdrKlockaLast
; lda <klocki+$1e0
; sta AdrKlockaLast
; lda >klocki+$1e0
; sta AdrKlockaLast+1
 lda $9d
 and #$04
E_9eb7 beq E_9ec3

 mwa #NewKlocek+$60 AdrKlockaLast
; lda <NewKlocek+$60
; sta AdrKlockaLast
; lda >NewKlocek+$60
; sta AdrKlockaLast+1
E_9ec3 mwa #Level $96
; lda <Level
; sta $96
; lda >Level
; sta $97
 jsr E_e4fa
 
E_9ece jsr ReadKey
 bcc E_9ece
 jsr E_e534
 lda #$00
 sta dmactl+1
 jsr Wait
 jmp LetsGo
E_9ee1 lda #$00
 sta $91
 lda $9d		;poziom pomnozymy x rozmiar mapy
 ldx #$00
 stx $97
 stx $a5
 asl @
 sta $96
 asl @
 tax
 adc $96
 sta $96
 bcc E_9efa
 inc $97
E_9efa txa		;wyliczamy komnate
 asl @
 rol $a5
 jsr E_e53d
 asl @
 rol $a5
 asl @
 rol $a5
 jsr E_e53d
 asl @
 rol $a5
 jsr E_e53d
 lda <Komnaty
 add:sta $96
 lda >Komnaty
 adc:sta $97
; lda $96
; clc
; adc <Komnaty
; sta $96
; lda $97
; adc >Komnaty
; sta $97

 ldx $9d		;pozycja poczatkowa bohatera wg numeru poziomu
 lda PosHero,x		;pod nim klocek wyjscia
 sta $a5
 ldy #$00
 ldx #$00
E_9f28 lda ($96),y
 eor #$95
 pha
 :$04 lsr @
 cmp $a5
 bcc E_9f37
 adc #$00
E_9f37 sta $0200,x
 inx
 pla
 and #$0f
 cmp $a5
 bcc E_9f44
 adc #$00
E_9f44 sta $0200,x
 inx
 iny
E_9f49 cpx #$dc
 bcc E_9f28
 rts
E_9f4e lda #$80		;ustaw zero w dziesiatce zegara XX0
 ldx #$05
 jsr E_acb1
 ldy $9d
 lda MaxTime,y		;czas na przejscie komnaty
 eor #$75		;aby utrudnic hackowanie, jest zaeorowane :)
; ora #%00100000		;+100 wiecej czasu

 pha
 and #$0f
 ora #$80
 jsr E_acb1

 pla
 lsr @
 lsr @
 lsr @
 lsr @
 ora #$80
 jsr E_acb1

 lda #$80		;zerowanie liczby kluczy
 ldx #32
 jsr E_acb1
 ldx #38
 jsr E_acb1
 rts
 
E_9f77 ldy #$0f		;wygas ekran i przejdz do nowego levelu
E_9f79 jsr E_e34c
 jsr PanelOff
 dec $01
 jsr Wait
 dey
 bne E_9f79
 inc $9d
 lda $9d		;level
 cmp #MaxLevel		;max level
 beq EndGame
 jmp NewLevel
 
EndGame jsr wait	;koniec gry, przeszles wszystkie levele
 lda #$00
 sta dmactl+1
 sta $d400
 jsr ClrSprite
 sta gtia+1

 mwa #fnt02 $f0
 mwa #FntBW $f2
 jsr depack

 lda <YouWin		;skonczyles cala gre i zobaczysz text :)
 sta $96
 lda >YouWin
 sta $97
 jsr E_e4fa
* lda #$00
* jsr E_3ca4
 lda #$0f
 sta $01
E_9fa3 jsr ReadKey
 bcc E_9fa3
 lda #$00
 sta dmactl+1
 jsr Wait
 jmp EkranPocz
E_9fb3 asl $8e
 asl $8e
 :$02 asl $8f
 sec
 rol $90
 sec
 rol $90
 sta $8a
 bit $9c
 bmi E_9fd6
 lda #$18
 ldx #$ff
 bit $8a
 bvs E_9fd3
 lda #$10
 ldx $90
E_9fd3 jsr E_9bfc
E_9fd6 bit $8a
 bpl E_a015
 lda $96
 sec
 sbc #$08
 sta $96
 bcs E_9fe5
 dec $97
E_9fe5 lda $98
 sec
 sbc #$08
 sta $98
 bcs E_9ff0
 dec $99
E_9ff0 lda $93
 cmp #$01
 beq E_a01c
E_9ff6 ldx #$2f
E_9ff8 lda $20,x
 sta $30,x
 dex
 bpl E_9ff8
 ldx #$0f
 ldy #$07
E_a003 lda ($98),y
 sta $20,x
 dex
 dey
 bpl E_a003
 ldy #$07
E_a00d lda ($96),y
 sta $20,y
 dey
 bpl E_a00d
E_a015 lda #$00
 ldx $8f
 jsr E_9bfc
E_a01c ldx #$10
 ldy #$00
 jsr E_9b78
 jsr E_a4c5
 jmp E_afd6
gos01 jsr E_9adc		;$a029 - ruch klocka w Prawo
 jsr E_9bd3
 jsr E_b022
 bit $86
 bvs E_a03c
 lda $8a
 and #$08
 beq E_a040
E_a03c lda #$80
 sta $9c
E_a040 inc $80
 jsr E_9bd3
E_a045 ldy #$18
 jsr E_9ae8
 lda #$ff
 sta $8e
 lda #$3f
 sta $8f
 lda #$40
 jsr E_a096
 lda #$00
 sta $9c
 sta $90
 jsr E_a096
 lda #$00
 jsr E_a096
 lda #$ff
 sta $8f
 lda #$80
 jsr E_a096
 dec $93		;przesuw klocka w prawo
 bne E_a075
 jmp E_9b61
E_a075 lda $94
 clc
 adc #$08
E_a07a sta $94
 bcc E_a080
 inc $95
E_a080 lda $9a
 clc
 adc #$08
 sta $9a
 bcc E_a08b
 inc $9b
E_a08b jsr E_b014
 lda $93
 and #$01
 bne E_a045
 beq E_a040
E_a096 lsr $8e
 lsr $8e
 :$02 lsr $8f
 sec
 ror $90
 sec
 ror $90
 sta $8a
 bit $9c
 bmi E_a0b9
E_a0aa lda #$00
 ldx #$ff
 bit $8a
 bvs E_a0b6
 lda #$08
 ldx $90
E_a0b6 jsr E_9bfc
E_a0b9 bit $8a
E_a0bb bpl E_a0fe
 lda $96
 clc
 adc #$08
 sta $96
 bcc E_a0c8
 inc $97
E_a0c8 lda $98
 clc
 adc #$08
 sta $98
 bcc E_a0d3
 inc $99
E_a0d3 lda $93
 cmp #$01
 beq E_a105
 ldx #$00
E_a0db lda $30,x
 sta $20,x
 inx
 cpx #$30
 bcc E_a0db
 ldx #$07
 ldy #$1f
E_a0e8 lda ($96),y
 sta $50,x
 dey
 dex
 bpl E_a0e8
 ldx #$08
 ldy #$18
E_a0f4 lda ($98),y
 sta $50,x
 inx
 iny
 cpx #$10
 bcc E_a0f4
E_a0fe lda #$18
 ldx $8f
 jsr E_9bfc
E_a105 ldx #$08
 ldy #$18
 jsr E_9b78
 jsr E_a4c5
 jmp E_afd6
E_a112 ldx #$0f
E_a114 lda $10,x
 sta $60,x
 dex
 bpl E_a114
 ldx #$00
E_a11d lda $20,x
 sta $12,x
 inx
 cpx #$10
 bcc E_a11d
 ldx #$00
E_a128 lda $30,x
 sta $26,x
 inx
 cpx #$10
 bcc E_a128
 ldx #$00
E_a133 lda $40,x
 sta $3a,x
 inx
 cpx #$10
 bcc E_a133
 ldx #$00
E_a13e lda $50,x
 sta $4e,x
 inx
 cpx #$10
 bcc E_a13e
 ldx #$07
 ldy #$3d
E_a14b lda $60,x
 sta $10,y
 dex
 dey
 lda $60,x
 sta $10,y
 tya
 sec
 sbc #$13
 tay
 dex
 bpl E_a14b
 ldx #$08
 ldy #$12
E_a163 lda $60,x
 sta $10,y
 inx
 iny
 lda $60,x
 sta $10,y
 tya
 clc
 adc #$13
 tay
 inx
 cpx #$10
 bcc E_a163
 rts

E_a17a lda #$00
 pha
 ldx $80
 dex
 lda $0200,x
 beq E_a189
 pla
 ora #$40
 pha
E_a189 inx
 inx
 lda $0200,x
 beq E_a194
 pla
 ora #$80
 pha
E_a194 jmp E_9bf4
gos03 jsr E_a112		;$a197 ruch klocka w Gore
 jsr E_a17a
 bit $87
 bvs E_a1a5
 bit $8a
 bvc E_a1a9
E_a1a5 lda #$80
 sta $9c
E_a1a9 lda $80
 sec
 sbc #$14
 sta $80
 jsr E_a17a
E_a1b3 lda #$0a
 sta $8e
 lda #$08
 sta $8f
 lda #$0e
 sta $90
 
 jsr E_a1ea
 lda #$00
 sta $9c
 mwa $98 $9a
; lda $98
; sta $9a
; lda $99
; sta $9b
 lda #$10
 sta $8e
 :$03 jsr E_a1ea
 dec $93
 bne E_a1e2
 jmp E_9b61
E_a1e2 lda $93
 and #$01
 bne E_a1b3
 beq E_a1a9
E_a1ea bit $9c
 bmi E_a20b
 ldy $8e
 :$02 dey
 sty $8e
 lda $36
 sta ($9a),y
E_a1f8 lda $37
 iny
 sta ($9a),y
E_a1fd tya
 clc
 adc #$07
 tay
 lda $4a
 sta ($9a),y
 lda $4b
 iny
 sta ($9a),y
E_a20b dec $8f
 dec $8f
 bit $86
 bvs E_a239
 bit $88
 bvs E_a22a
 ldy $8f
 lda ($94),y
 sta $10
 and #$fc
 sta ($94),y
 iny
 lda ($94),y
 sta $11
 and #$fc
 sta ($94),y
E_a22a bit $89
 bvs E_a239
 ldy $8f
 lda $20
 sta ($98),y
 iny
 lda $21
 sta ($98),y
E_a239 bit $86
 bmi E_a26b
 bit $88
 bmi E_a258
 lda $8f
 clc
 adc #$18
 tay
 lda ($94),y
 sta $4c
 and #$3f
 sta ($94),y
 iny
 lda ($94),y
 sta $4d
 and #$3f
 sta ($94),y
E_a258 bit $89
 bmi E_a26b
 lda $8f
 clc
 adc #$18
 tay
 lda $5c
 sta ($98),y
 iny
 lda $5d
 sta ($98),y
E_a26b lda #$04
 sta $91
 ldy #$11
E_a271 ldx #$12
E_a273 lda $10,y
 sta $12,y
 dey
 dex
 bne E_a273
 tya
 clc
 adc #$26
 tay
 dec $91
 bne E_a271
 ldy $90
 :$02 dey
 sty $90
 cpy #$06
 bne E_a29d
 dec $8d
 jsr E_a421
 lda $93
 cmp #$01
 beq E_a2c4
 ldy #$0e
E_a29d lda ($94),y
 sta $24
 lda #$00
 sta ($94),y
 iny
 lda ($94),y
 sta $25
 lda #$00
 sta ($94),y
 tya
 clc
 adc #$07
 tay
 lda ($94),y
 sta $38
 lda #$00
 sta ($94),y
 iny
 lda ($94),y
 sta $39
 lda #$00
 sta ($94),y
E_a2c4 jsr E_a515
 jmp E_afd6
gos02 jsr E_a112		;$a2ca - ruch klocka w Dol
 jsr E_a17a
 bit $87
 bmi E_a2da
 lda $8a
 and #$02
 beq E_a2de
E_a2da lda #$80
 sta $9c
E_a2de lda $80
 clc
 adc #$14
 sta $80
 jsr E_a17a
E_a2e8 lda #$0c
 sta $8e
 lda #$fe
 sta $8f
 lda #$08
 sta $90
 jsr E_a31f
 lda #$00
 sta $9c
 lda $96
 sta $94
 lda $97
 sta $95
 lda #$06
 sta $8e
 :$03 jsr E_a31f
 dec $93
 bne E_a317
 jmp E_9b61
E_a317 lda $93
 and #$01
 bne E_a2e8
 beq E_a2de
E_a31f bit $9c
 bmi E_a340
 ldy $8e
 :$02 iny
 sty $8e
 lda $24
 sta ($94),y
 iny
 lda $25
 sta ($94),y
 tya
 clc
 adc #$07
 tay
 lda $38
 sta ($94),y
 iny
 lda $39
 sta ($94),y
E_a340 inc $8f
 inc $8f
 bit $86
 bvs E_a36e
 bit $88
 bvs E_a35f
 ldy $8f
 lda ($9a),y
 sta $22
 and #$fc
 sta ($9a),y
 iny
 lda ($9a),y
 sta $23
 and #$fc
 sta ($9a),y
E_a35f bit $89
 bvs E_a36e
 ldy $8f
 lda $12
 sta ($96),y
 iny
 lda $13
 sta ($96),y
E_a36e bit $86
 bmi E_a3a0
 bit $88
 bmi E_a38d
 lda $8f
 clc
 adc #$18
 tay
 lda ($9a),y
 sta $5e
 and #$3f
 sta ($9a),y
 iny
 lda ($9a),y
 sta $5f
 and #$3f
 sta ($9a),y
E_a38d bit $89
 bmi E_a3a0
 lda $8f
 clc
 adc #$18
 tay
 lda $4e
 sta ($96),y
 iny
 lda $4f
 sta ($96),y
E_a3a0 lda #$04
 sta $91
 ldy #$00
E_a3a6 ldx #$12
E_a3a8 lda $12,y
 sta $10,y
 iny
 dex
 bne E_a3a8
 :$02 iny
 dec $91
 bne E_a3a6
 ldy $90
 :$02 iny
 sty $90
 cpy #$10
 bne E_a3cf
 inc $8d
 jsr E_a421
 lda $93
 cmp #$01
 beq E_a3f6
 ldy #$08
E_a3cf lda ($9a),y
 sta $36
 lda #$00
 sta ($9a),y
 iny
 lda ($9a),y
 sta $37
 lda #$00
 sta ($9a),y
 tya
 clc
 adc #$07
 tay
 lda ($9a),y
 sta $4a
 lda #$00
 sta ($9a),y
 iny
 lda ($9a),y
 sta $4b
 lda #$00
 sta ($9a),y
E_a3f6 jmp E_a2c4
 lda $8d
 asl @
 tax
 inx
 ldy #$07
E_a400 lda E_aac6,x
 sta $94,y
 dex
 dey
 bpl E_a400
 rts
E_a40b lda #$00
 sta $a6
 lda $81
 :$04 asl @
 rol $a6
 sta $a5
 lda $82
 asl @
 clc
 adc #$02
 sta $8d
E_a421 lda $8d
 asl @
 tax
 inx
 ldy #$07
E_a428 lda E_aac6,x
 sta $94,y
 dex
 dey
 bpl E_a428
 ldx #$06
E_a434 lda $94,x
 clc
 adc $a5
 sta $94,x
 lda $95,x
 adc $a6
 sta $95,x
 :$02 dex
E_a443 bpl E_a434
 rts
E_a446 lda #$00
 sta $95
E_a44a lda $82
 :$04 asl @
 sta $91
 asl @
 rol $95
 asl @
 rol $95
 sta $94
 lda $81
 asl @
 adc $91
 adc $94
 sta $94
 bcc E_a467
 inc $95
E_a467 lda <pole_gry
 add:sta $94
 lda >pole_gry
 adc:sta $94+1
; lda $94
; clc
; adc #$e8
; sta $94
; lda $95
; adc #$2b
; sta $95
 ldy #$00
 jsr E_a483
 iny
 jsr E_a483
 ldy #$28
 jsr E_a483
 iny
E_a483 lda ($94),y
 eor #$80
 sta ($94),y
 rts
E_a48a sec
 sbc #$01
 asl @
 tax

 mwa AdrKlocka,x $94
; lda AdrKlocka,x
; sta $94
; lda AdrKlocka+1,x
; sta $95
 ldx #$0f
E_a49b txa
 tay
 lda ($94),y
 pha
 txa
 clc
 adc #$08
E_a4a4 tay
 pla
 sta ($96),y
 dex
 bpl E_a49b
 lda #$10
 add:sta $94
 scc:inc $95
; lda $94
; clc
; adc #$10
; sta $94
  
 ldx #$0f
E_a4b4 txa
 tay
 lda ($94),y
 pha
 txa
 clc
 adc #$08
 tay
 pla
 sta ($98),y
 dex
 bpl E_a4b4
 rts
E_a4c5 lda $ac
 beq E_a4cc
 jsr E_a4cc
E_a4cc ldx $85
 lda $83
 clc
 adc E_af91,x
 sta $83
 dec $ab
 ldx $a8
 bne E_a505
 ldx $8b
 bmi E_a4eb
 pha
 sta $d000		;pozX sprita 0 i 1
 sta $d001
 jsr E_a57a
 pla
E_a4eb sta $d002
 sta $d003
 sta $d007
 tax
 :$02 inx
 stx $d006
 :$02 inx
 stx $d005
 :$02 inx
 stx $d004
 rts
E_a505 sta $d000
 sta $d001
 clc
 adc #$08
 sta $d004
 sta $d005
 rts
E_a515 lda $ac
 beq E_a51c
 jsr E_a51c
E_a51c dec $ab
 ldx $85
 lda $84
 clc
 adc E_af91,x
 sta $84
E_a528 bit $8b
 bmi E_a53e
 tax
 ldy #$14
 lda #$00
E_a531 sta pmg+$400,x
 sta pmg+$500,x
 inx
 dey
 bne E_a531
 jsr E_a57a
E_a53e bit $8c
 bmi E_a560
 ldx $84
 ldy #$00
 bvc E_a561
E_a548 lda E_b28a,y
 sta pmg+$300+$fe,x
 lda E_b272,y
 sta pmg+$400+$fe,x
 lda E_b2a2,y
 sta $02fe,x
 inx
 iny
 cpy #$18
 bcc E_a548
E_a560 rts
E_a561 lda E_27c0,y
 sta pmg+$600,x
 lda E_27d2,y
E_a56a sta pmg+$700,x
 lda E_27e4,y
 sta pmg+$300,x
 inx
 iny
E_a575 cpy #$14
 bcc E_a561
 rts
E_a57a ldx $84
 lda $85
 ldy $8b
 bpl E_a586
 ldx $b1
 lda $b2
E_a586 ldy #$00
 cmp #$02
 bne E_a592
 jsr E_b348
 jmp E_a5a3
E_a592 lda ($a0),y
E_a594 sta pmg+$400+2,x
 iny
 lda ($a0),y
E_a59a sta pmg+$500+2,x
 inx
 iny
 cpy #$20
 bcc E_a592
E_a5a3 lda $8c
 bpl E_a560
 lda $a0
 clc
 adc #$20
 sta $a0
 bcc E_a560
 inc $a1
 rts
 ldx $84
E_a5b5 lda #$00
 ldy #$12
E_a5b9 sta pmg+$400,x
 sta pmg+$500,x
 inx
 dey
 bne E_a5b9
 rts
E_a5c4 ldx $84
 ldy #$16
 lda #$00
E_a5ca sta $02fe,x
 sta pmg+$300+$fe,x
 sta pmg+$400+$fe,x
 inx
 dey
 bne E_a5ca
 rts
E_a5d8 lda #$c0
 ldx $81
 beq E_a5e4
 and #$80
 cpx #$13
 beq E_a5e6
E_a5e4 and #$40
E_a5e6 sta $86
 lda #$c0
 ldx $82
 beq E_a5f4
 and #$40
 cpx #$0a
 beq E_a5f6
E_a5f4 and #$80
E_a5f6 sta $87
 rts

;--------- 
;- START
;---------
start lda 20
 cmp 20
 beq *-2

 lda #$00
 sta $d40e
 sta $d20e
 sta $d400
 sei
 lda #$fe
 sta $d301
 
 mwa #nmi $fffa		;nowy adres przerwan NMI
 mwa #irq $fffe		;nowy adres przerwan IRQ

 cld
 lda #$00
 ldx #$04
E_9c4e sta $d008,x
 dex
 bpl E_9c4e
 jsr E_ad10
 mwa #pole_gry $94	;wypelniamy POLE_GRY wartosciami od 0..119
; lda #$e8
; sta $94
; lda #$2b
; sta $95
 ldx #$07
E_9c61 ldy #120-1
E_9c63 tya
 sta ($94),y
 dey
 bpl E_9c63
 lda #120
 add:sta $94
 scc:inc $94+1
; lda $94
; clc
; adc #$78
; sta $94
; bcc E_9c74
; inc $95
E_9c74 dex
 bne E_9c61
 ldy #$27
E_9c79 tya
 sta ($94),y
 dey
 bpl E_9c79
 
 lda #$03
 sta $d01d
 lda #$00
 sta $d407
EkranPocz lda $d40b
 bne *-3
 lda #$00
 sta dmactl+1
 sta $d400
 jsr ClrSprite
 sta gtia+1
 
* lda #$00
* jsr E_3ca4

; lda #$00
 lda #$0f
 sta $01
 sta k709+1
 lda <dli2
 sta dli_LMS+1
 sta DliVec+1
 lda >dli2
 sta dli_MSB+1
 sta DliVec+2
 
 lda #$60
 sta mpt
 jsr msxStop
 mwa #msxTitle $f0	;rozpakuj muze mental01
 mwa #msx-6 $f2
 jsr depack
 ldy #15	;wyciszamy
w_0 tya
 sta cisza,y
 dey
 bpl w_0


 mwa #fnt00 $f0
 mwa #FntLog1 $f2
 jsr depack
 mwa #fnt02 $f0
 mwa #FntBW $f2
 jsr depack
 mwa #fnt03 $f0
 mwa #FntProd $f2
 jsr depack
 
 ldy #0			;tworzymy obszar wyswietlania dla ANTIC-a
c0 lda log1,y		;jeden jednolity obszar
 sta scr-280,y		;przepisujemy 280 bajtow log1 i log2
 lda log2,y		;przed SCR i za SCR
 sta scr+480,y 		;SCR zajmuje 480 bajtow (120x4)
 iny
 bne c0
 ldy #23
c1 lda log1+256,y
 sta scr-280+256,y
 lda log2+256,y
 sta scr+480+256,y 
 dey
 bpl c1

 lda #0
 ldy #$1f		;czyscimy 4znaki
c3 sta FntBw+$1c*32-32,y
 sta FntBw2+$1c*32-32,y
 dey
 bpl c3
 ldy #$f		;modyfikuje zestaw znakow, aby kropka byla na srodku
c2 lda FntBw2+$1b*32-32,y
 sta FntBw+$1c*32-16,y
 dey
 bpl c2

 jsr BufPasMove

 ldy #3
 lda #0
col_ sta $f4,y
 dey
 bpl col_
 sta GlownaPetla+1
 sta Faza2+1
 sta Faza3+1

 lda #129
 sta Wstep+1
 lda #0
 sta Wstep2+1
 

 lda >FntProd		;taquart & madteam production
 sta md00+1
 ldy #6
 sta TabFnt,y
 dey
 bpl *-4 
 lda >FntLog1
 sta FntBase+1		;fntBW
antOFF lda #$22
 bne antO_

 lda #0
 
antO_ sta dmactl+1
 mwa #ant0_ modAnt
 mwa #ant0 $d402

; lda #0	$22
; sta dmactl+1
 lda <tabFnt
 sta pozY+1
 lda #$c0
 sta $d40e
 
;- tutaj init MPT+sample
;	ldy <msx	;init msx
;	ldx >msx
;	lda #0
;	jsr mpt
;	ldy <smp-32	;init sampli
;	ldx >smp-32
;	lda #3
;	jsr mpt
;	ldx #0		;graj song
;	lda #2
;	jsr mpt

 jsr mpt+3		;init muzy
	
 jsr wait
modVBL lda <Wstep
 sta VBLv+1
modVBL_ lda >Wstep
 sta VBLv+2
 
 lda <Wstep2		;wylacz napis production i przejdz od razu do ekranu tytulowego
 sta modVBL+1
 lda >Wstep2
 sta modVBL_+1
 lda #0
 sta antOFF+1

PassExit mwa #Jump VBLjmp+1
 mwa #Petla Petla+1
	
;	ldx #1		;graj sample
;	lda #5
;	jsr mpt

playMusic lda #$60
 sta mpt

Petla jmp petla

;---------
 
LetsGo lda <dli0	;Tworzymy plansze i gramy
 sta dli_LMS+1
 lda >dli0
 sta dli_MSB+1

 mwa #ant1 $d402
* lda #$99
* sta $d402
* lda #$af
* sta $d403

 lda >Fnt
 sta FntBase+1		;Fnt
* lda #$01		;zmiany granej muzyczki
* jsr E_3ca4
 lda #$0f
 sta $01
 lda #$71
 sta gtia+1
E_a620 jsr E_9ee1
 jsr E_aee1
 lda #$3e
 sta dmactl+1
 lda #$00
 sta $a5
 ldx #$07
E_a631 lda $70,x
 and #$0f
 cmp $a5
 bcc E_a63d
 sta $a5
 stx $a6
E_a63d dex
 bpl E_a631
 ldx $a6
 lda $70,x
 and #$f0
 sta $f0,x
E_a648 ldx #$07
 jsr Wait
E_a64d cpx $a6
 beq E_a675
 lda $70,x
 and #$0f
 sta $91
 lda $a5
 sec
 sbc $91
 sta $91
 ldy $a6
 lda $f0,y
 and #$0f
 cmp $91
E_a667 bcc E_a675
 beq E_a66f
 inc $f0,x		;wygaszanie kolorow ekranu z gra
 bne E_a675
E_a66f lda $70,x
 and #$f0
 sta $f0,x
E_a675 dex
 bpl E_a64d
 ldx $a6
 lda $f0,x
 and #$0f
 cmp $a5
 beq E_a686
 inc $f0,x
 bne E_a648
E_a686 jsr E_a99e
 beq E_a693
 jsr ReadKey		;test nasisniecia klawiszy lub joya
 bcc E_a686
 jmp E_b063
E_a693 cpx $85
 beq E_a69f
 stx $85
E_a699 jsr E_b333
 jsr E_a57a
E_a69f jsr E_aa00
 bcs E_a686
 jsr E_a6aa		;hmm, chyba animacja wybuchu itp
 jmp E_a686
E_a6aa lda $80
 clc
 adc E_af81,x
 tay
 lda $0200,y
 beq E_a6d3
 cmp #$0a
 bne E_a6c2
 jsr E_a6ff
 :$02 pla
 jmp E_9f77
E_a6c2 bcs E_a6c6
 bcc E_a6ff
E_a6c6 sbc #$0b
 asl @
 tax
 lda E_af85+1,x
 pha
 lda E_af85,x
 pha
E_a6d2 rts
E_a6d3 ldy $80
 ldx $0200,y
 cpx #$08
 bcs E_a6d2
 cpx #$07
 bne E_a6e3
 jmp E_a76a
E_a6e3 cpx #$05
 bcs E_a6ef
 dex
 cpx $85
 bne E_a6d2
 jmp E_a76a
E_a6ef bne E_a6f8
 lda $85
 cmp #$02
 bcc E_a76a
 rts
E_a6f8 lda $85
 cmp #$02
 bcs E_a76a
 rts
E_a6ff ldx $85
 cpx #$02
 bcs E_a72f
 lda #$07
 sta $ab
E_a709 jsr E_afd6
 jsr E_a4c5
 bit $8b
 bvc E_a716
 jsr E_ab3a
E_a716 lda $ab
 bmi E_a756
 bne E_a709
 jsr E_b333
 jsr E_afd6
 jsr E_a4c5
 bit $8b
 bvc E_a72c
 jsr E_ab6c
E_a72c jmp E_a756
E_a72f lda #$07
 sta $ab
E_a733 jsr E_afd6
 jsr E_a515
 bit $8b
 bvc E_a740
 jsr E_ab3a
E_a740 lda $ab
 bmi E_a756
 bne E_a733
E_a746 jsr E_b333
 jsr E_afd6
 jsr E_a515
 bit $8b
 bvc E_a756
 jsr E_ab6c
E_a756 jsr E_a92f
 lda $8b
 and #$80
 sta $8b
 lda $80
 clc
 adc E_af81,x
 sta $80
 jmp E_a5d8
E_a76a ldx $80
 lda $0200,x
 sec
 sbc #$01
 asl @
 tax
 mwa AdrKlocka,x $94
; lda AdrKlocka,x
; sta $94
; lda AdrKlocka+1,x
; sta $95
 ldx #$37
 lda #$00
E_a782 sta E_27c0,x
 dex
 bpl E_a782
 jsr E_afeb
 ldy #$1f
 lda #$11
 sta $02e5
 lda #$23
 sta $02e6
 lda #$35
 sta $02e7
E_a79c lda #$01
 sta $8d
E_a7a0 lda #$04
 sta $93
 lda $10,y
E_a7a7 pha
 and #$03
 beq E_a7b9
 tax
 lda $02e4,x
 tax
 lda $8d
 ora E_27c0,x
 sta E_27c0,x
E_a7b9 pla
 :$02 lsr @
E_a7bc asl $8d
 dec $93
 bne E_a7a7
 dey
 bmi E_a7d6
 tya
 and #$01
 beq E_a7a0
 dec $02e5
 dec $02e6
 dec $02e7
 jmp E_a79c
E_a7d6 lda #$00
 sta $8c
 lda $83
 jsr E_a4eb
 jsr E_a53e
 jsr E_a40b
 lda #$00
 ldy #$08
E_a7e9 sta ($96),y
 sta ($98),y
 iny
 cpy #$18
 bcc E_a7e9
 jsr E_a446
E_a7f5 jsr E_ac2f
 bit $86
 bpl E_a7fe
 and #$6b
E_a7fe bvc E_a802
 and #$d6
E_a802 bit $87
 bvc E_a808
 and #$1f
E_a808 bpl E_a80c
 and #$f8
E_a80c sta $8a
 lda $82
 lsr @
 sta $95
 ror @
 and #$80
 sta $94
 lda $82
 asl @
 clc
 adc $95
 sta $95
 lda $81
 :$04 asl @
 bcc E_a82b
 inc $95
 clc
E_a82b adc $94
 bcc E_a832
 inc $95
 clc
E_a832 adc $78
 sta $94
 lda $95
 adc $79
 sta $95
 lda #$00
 sta $91
 jsr E_9a80
 lda $94
 clc
 adc #$40
 sta $94
 lda $95
 adc #$01
 sta $95
 lda #$08
 sta $91
 jsr E_9a80
 lda $94
 clc
 adc #$40
 sta $94
 lda $95
 adc #$01
 sta $95
 bit $87
 bvs E_a86d
 ldx #$0a
 jsr E_9ac9
E_a86d bit $87
 bmi E_a883
 lda $94
 sec
 sbc #$ba
 sta $94
 lda $95
 sbc #$03
 sta $95
 ldx #$02
 jsr E_9ac9
E_a883 ldy #$00
 lda $8a
E_a887 and #$02
 beq E_a893
 sty $30
 sty $31
 sty $40
 sty $41
E_a893 bit $8a
 bvc E_a89f
 sty $3e
 sty $3f
 sty $4e
 sty $4f
E_a89f lda $8a
 and #$08
 beq E_a8b0
 ldx #$0f
E_a8a7 lda $30,x
 and #$3f
 sta $30,x
 dex
 bpl E_a8a7
E_a8b0 lda $8a
 and #$10
 beq E_a8c3
 ldx #$10
E_a8b8 lda $30,x
 and #$fc
 sta $30,x
 inx
 cpx #$20
 bcc E_a8b8
E_a8c3 lda $8a
 and #$01
 beq E_a8d9
 sty $20
 sty $21
 lda $12
 and #$3f
 sta $12
 lda $13
 and #$3f
 sta $13
E_a8d9 lda $8a
 and #$04
 beq E_a8ef
 sty $50
 sty $51
 lda $14
 and #$fc
 sta $14
 lda $15
 and #$fc
 sta $15
E_a8ef lda $8a
 and #$20
 beq E_a905
 sty $2e
 sty $2f
 lda $1a
 and #$3f
 sta $1a
 lda $1b
 and #$3f
 sta $1b
E_a905 bit $8a
 bpl E_a919
 sty $5e
 sty $5f
 lda $1c
 and #$fc
 sta $1c
 lda $1d
 and #$fc
 sta $1d
E_a919 jsr E_a40b
 jsr E_b038
 jsr E_afd6
 lda $85
 asl @
 tax
 lda E_af71+1,x
 pha
 lda E_af71,x
 pha
 rts
 
E_a92f ldx $85
 lda $81
 clc
 adc E_af79,x
 sta $81
 lda $82
 clc
 adc E_af7d,x
 sta $82		
 rts
sub01 inc $9f		;$a942 - inny klucz ?
 ldx #38
 bne E_a94c
sub00 inc $9e		;$a948 - otwarcie drzwi kluczem
 ldx #32
E_a94c jsr E_acc9
E_a94f mwa #klocki+$100 E_a975+1
; lda <klocki+$100
; sta E_a975+1
; lda >klocki+$100
; sta E_a975+2
 jsr E_a6ff
 jsr E_a40b
 ldx $80
 lda #$09
E_a963 sta $0200,x
E_a966 ldx #$00
 jsr E_a973
 mwa $98 $96
; lda $98
; sta $96
; lda $99
; sta $97
E_a973 ldy #$08
E_a975 lda $ffff,x	$014d,x
 sta ($96),y
 inx
 iny
 cpy #$18
 bcc E_a975
 rts
sub02 lda $9e		;$a981 - zabiera klucz ?
 beq E_a99d
 dec $9e
 ldx #32		;ofset do licznika w panelu
 jsr Zmniejsz
 jmp E_a94f
sub03 lda $9f		;$a98f - zabiera klucz ?
 beq E_a99d
 dec $9f
 ldx #38		;ofset do licznika w panelu
 jsr Zmniejsz
 jmp E_a94f
E_a99d rts
E_a99e jsr E_acdd
 lda $d300
 and #$0f
 sta $91
E_a9a8 ldx #$03
E_a9aa cmp TstJoy,x		;testowanie Joya
 beq E_a99d
 dex
 bpl E_a9aa
 lda $d20f
 and #$04
 bne E_a99d
E_a9b9 lda $d209
 cmp #$0a
 bne E_a9f5
 lda #$a5
 sta Zegar
 jsr E_ad10
E_a9c8 jsr ReadKey
 bcc E_a9c8
 jsr E_ada1
 lda #$c6
 sta Zegar
 bit $8c
 bvs E_a9e0
 jsr E_b333
 jsr E_a57a
 rts
E_a9e0 jsr E_a528
 lda #$60
 sta E_b0b1
E_a9e8 jsr E_b072
 lda #$a9
 sta E_b0b1
 lda #$0f
 sta $91
 rts
E_a9f5 ldx #$03
E_a9f7 cmp E_ab1a,x
 beq E_a99d
 dex
 bpl E_a9f7
 rts
E_aa00 lda $81
 ldx $85
 cmp E_ab16,x
 beq E_aa1c
 lda $82
 cmp E_af6d,x
 beq E_aa1c
 clc
 rts

ReadKey lda $00
 bne E_aa1e
 lda $a7
 bne E_aa38
 inc $a7
E_aa1c sec
 rts
E_aa1e lda $d20f		;odczyt klawiatury
 and #$04
 bne E_aa34
 lda $a7
 bne E_aa38
E_aa29 inc $a7
 lda $d209
 cmp #$21
 bne E_aa3a
 sec
 rts
E_aa34 lda #$00
 sta $a7
E_aa38 lda #$ff
E_aa3a clc
 rts
 
;------------
;- tablice
;-
E_aac6
 dta a(Fnt-8,Fnt-8+320,Fnt-8+640,Fnt-8+1024,Fnt-8+1344,Fnt-8+1664,Fnt-8+2048,Fnt-8+2368,Fnt-8+2688,Fnt-8+3072)
 dta a(Fnt-8+3392,Fnt-8+3712,Fnt-8+4096,Fnt-8+4416,Fnt-8+4736,Fnt-8+5120,Fnt-8+5440,Fnt-8+5760,Fnt-8+6144)
 dta a(Fnt-8+6464,Fnt-8+6784,Fnt-8+7168,Fnt-8+7488,Fnt-8+7808)
; dta b($f8,$07,$38,$09,$78,$0a,$f8,$0b,$38,$0d,$78,$0e,$f8,$0f,$38,$11)	;tablica ofsetow, co 320
; dta b($78,$12,$f8,$13,$38,$15,$78,$16,$f8,$17,$38,$19,$78,$1a,$f8,$1b)
; dta b($38,$1d,$78,$1e,$f8,$1f,$38,$21,$78,$22,$f8,$23,$38,$25,$78,$26)
AdrKlocka dta a(klocki,klocki+$20,klocki+$40,klocki+$60,klocki+$80,klocki+$a0,klocki+$c0,klocki+$e0)
 dta a(klocki+$100,klocki+$120,klocki+$140,klocki+$160,klocki+$180,klocki+$1a0,klocki+$1c0)
AdrKlockaLast dta a(klocki+$1e0)
E_ab16 dta b($00,$13,$ff,$ff)		;cmp
E_ab1a dta b($20,$22,$17,$3f)		;cmp


;-
;- animacja itp
;-
sub04 jsr E_a6ff
 lda #$40
 sta $8b
 mwa #Wybuch+$00 E_ab41+1	;nowy ksztalt_pierwsza linia zestawu znakow
 mwa #Wybuch+$10 E_ab46+1	;nowy ksztalt_druga linia zestawu znakow
 rts
 
E_ab3a jsr E_a40b		;subroutine
 ldx #16-1	$0f
 ldy #24-1	$17
E_ab41 lda $ffff,x		$014d,x
 sta ($96),y
E_ab46 lda $ffff,x		$014d,x
 sta ($98),y
 dey
 dex
 bpl E_ab41			;zwieksz o 32
 lda E_ab41+1
 clc
 adc #$20
 sta E_ab41+1
 bcc E_ab5d
 inc E_ab41+2
E_ab5d lda E_ab46+1
 clc
 adc #$20
 sta E_ab46+1
 bcc E_ab6b
 inc E_ab46+2
E_ab6b rts
E_ab6c lda E_a919
 pha
 lda #$60		;rts - modyfikacja
 sta E_a919
 jsr E_a7f5
 pla
 sta E_a919
 jsr E_a40b
 lda $94
 sta E_ac29+1
 lda $95
 sta E_ac29+2
 jsr E_ac2f
 lda $8a
 and #$08
 php
 lda $8a
 and #$10
 php
 lda $86
 plp
 beq E_ab9d
 ora #$80
E_ab9d plp
 beq E_aba2
 ora #$40
E_aba2 sta $86
 lda $8a
 and #$02
 php
E_aba9 bit $8a
E_abab php
 lda $87
E_abae plp
E_abaf bvc E_abb3
 ora #$40
E_abb3 plp
 beq E_abb8
 ora #$80
E_abb8 sta $87
E_abba bit $86
 bmi E_abce
E_abbe ldx #$07
 ldy #$1f
E_abc2 lda $50,x
 sta ($96),y
 lda $58,x
 sta ($98),y
 dey
 dex
 bpl E_abc2
E_abce bvs E_abe0
 ldx #$07
 ldy #$07
E_abd4 lda $20,x
 sta ($96),y
 lda $28,x
 sta ($98),y
 dex
 dey
 bpl E_abd4
E_abe0 lda $87
 bmi E_abeb
 ldx #$02
 ldy #$0e
E_abe8 jsr E_ac1c
E_abeb bit $87
E_abed bvs E_ac00
E_abef ldx #$0a
 ldy #$08
 lda $9a
 sta E_ac29+1
E_abf8 lda $9b
 sta E_ac29+2
E_abfd jsr E_ac1c
E_ac00 jsr E_a446
 ldx #$00
 ldy #$08
 jsr E_ac0c
 ldx #$10
E_ac0c lda $30,x
 sta ($96),y
 lda $38,x
 sta ($98),y
 inx
 iny
 txa
 and #$07
 bne E_ac0c
 rts
E_ac1c jsr E_ac24
 tya
 clc
 adc #$06
 tay
E_ac24 jsr E_ac27
E_ac27 lda $10,x
E_ac29 sta $ffff,y		$014d,y
 inx
 iny
 rts
E_ac2f lda #$00
 pha
 lda $80
 sec
 sbc #$15
 tax
 lda $0200,x
 beq E_ac41
 pla
 ora #$01
 pha
E_ac41 inx
 lda $0200,x
 beq E_ac4b
 pla
 ora #$02
 pha
E_ac4b inx
 lda $0200,x
 beq E_ac55
 pla
 ora #$04
 pha
E_ac55 ldx $80
 lda $0200,x
 sta $92
 lda #$00
 sta $0200,x
 dex
 lda $0200,x
 beq E_ac6b
 pla
 ora #$08
 pha
E_ac6b inx
 inx
 lda $0200,x
 beq E_ac76
 pla
 ora #$10
 pha
E_ac76 txa
 clc
 adc #$14
 tax
 lda $0200,x
 beq E_ac84
 pla
 ora #$80
 pha
E_ac84 dex
 lda $0200,x
 beq E_ac8e
 pla
 ora #$40
 pha
E_ac8e dex
 lda $0200,x
 beq E_ac98
 pla
 ora #$20
 pha
E_ac98 pla
 sta $8a
 rts

*--
ClrSprite ldx #$07
 lda #$00
cl_ sta $d000,x
 dex
 bpl cl_
 rts
 
E_af6d dta b($ff,$ff,$0a,$00)			;data
E_af71 dta a(gos00-1,gos01-1,gos02-1,gos03-1)
E_af79 dta b($ff,$01,$00,$00)
E_af7d dta b($00,$00,$01,$ff)
E_af81 dta b($ff,$01,$14,$ec)
E_af85 dta a(sub00-1,sub01-1,sub02-1,sub03-1,sub04-1,E_9ac8-1)
E_af91 dta b($ff,$01,$02,$fe)		;0,+1,+2,-1 parametr dodawania
TstJoy dta b($0b,$07,$0d,$0e)		;kierunki joysticka


AdrSprite dta a(duch+$200,duch,duch+$100,duch+$100)	;$afc6
 dta b($00,$48,$38,$34,$92,$94,$78,$9a)

E_afd6 jsr E_acdd
 lda $8b
 eor #$ff
 and $8c
E_afdf bpl Wait		;szybszy ruch sprita  (1ramka)
 jsr Wait		;normalny ruch sprita (2ramki)
Wait lda clock
 cmp clock
 beq *-2
 rts
E_afeb ldx #$00		;przesuw klocka
E_afed ldy #$00
E_afef jsr E_b004
 ldx #$01
 ldy #$08
 jsr E_b004
E_aff9 ldx #$10
E_affb ldy #$10
 jsr E_b004
 ldx #$11
 ldy #$18
E_b004 lda #$08
 sta $93
E_b008 lda ($94),y
 sta $10,x
 :$02 inx
 iny
 dec $93
 bne E_b008
 rts
E_b014 ldx #$03
E_b016 lda $10,x
 sta $12,x
 lda $18,x
 sta $1a,x
 dex
 bpl E_b016
 rts
E_b022 ldx #$02
 jsr E_b029
 ldx #$0a
E_b029 jsr E_b02d
 inx
E_b02d lda $10,x
 pha
 lda $12,x
E_b032 sta $10,x
 pla
 sta $12,x
 rts
E_b038 lda #$00
 sta $93
 ldy $80
 ldx $85
E_b040 lda $81
 cmp E_ab16,x
 beq E_b060
 lda $82
 cmp E_af6d,x
 beq E_b060
 tya
 clc
 adc E_af81,x
 tay
 lda $0200,y
 bne E_b060
 jsr E_a92f
 inc $93
 bne E_b040
E_b060 asl $93
 rts
E_b063 lda $8b
 pha
E_b066 ldx #$05
E_b068 lda $80,x
 sta $ad,x
 dex
 bpl E_b068
 inx
 stx $ac
E_b072 lda $70
 sta $f2
 lda $71
 sta $f3
 jsr E_afd6
 ldx #$06
 stx E_a594+2
 stx E_b34f+2
 inx
 stx E_a59a+2
 stx E_b355+2
 lda #$80
 sta $8b
 lda #$40
 sta $8c
 jsr E_b333
 jsr E_a57a
 lda $b0
 sta $d002
 sta $d003
 ldx #$04
 stx E_a594+2
 stx E_b34f+2
 inx
 stx E_a59a+2
 stx E_b355+2
E_b0b1 lda #$ec
 sta $f0
 lda #$e8
 sta $f1
 ldx $b1
 jsr E_a5b5
 lda #$21
 sta E_b2ea+1
 dec $83
 lda $83
 sta $d000
 sta $d001
 clc
 adc #$08
 sta $d004
 sta $d005
 inc $a8
 lda $aa
 bne E_b0e3
 jsr E_b373
 inc $aa
 bne E_b0e6
E_b0e3 jsr E_a53e
E_b0e6 jsr E_a99e
 bne E_b0fb
 stx $85
 jsr E_aa00
 bcs E_b0e6
 jsr E_a6ff
 lda #$01
 sta $ac
 bne E_b0e6
E_b0fb lda $91
 cmp #$0f
 beq E_b170
 sta $8d
 ldx #$02
 lda #$01
 tay
E_b108 and $8d
 bne E_b115
 tya
 eor #$0f
 pha
 eor #$0f
 dex
 beq E_b119
E_b115 asl @
 tay
 bne E_b108
E_b119 pla
 jsr E_a9a8
 stx $a5
 pla
 jsr E_a9a8
 stx $a6
 stx $85
 jsr E_aa00
E_b12a bcs E_b0e6
 lda $a5
 sta $85
 jsr E_aa00
 bcs E_b0e6
 lda $a5
 cmp $a6
 bcc E_b141
 ldx $a6
 stx $a5
 sta $a6
E_b141 lda #$08
 ldx $ac
 beq E_b148
 lsr @
E_b148 sta $93
E_b14a lda $a5
 sta $85
 jsr E_a4c5
 lda $a6
 sta $85
 jsr E_a515
 jsr E_afd6
 dec $93
 bne E_b14a
 jsr E_a756
 lda $a5
 sta $85
 jsr E_a756
 lda #$01
 sta $ac
 jmp E_b0e6
E_b170 lda #$00
 sta $ac
 jsr ReadKey
 bcs E_b17c
 jmp E_b0e6
E_b17c jsr E_afd6
 lda $b0
 sta $d000
 sta $d001
 jsr E_a5c4
 lda $b2
 sta $85
 jsr E_b333
 ldx $b1
 jsr E_b361
 jsr E_a57a
 lda #$31
 sta E_b2ea+1
 dec $a8
 lda $74
 sta $f2
 sta $d014
 lda $75
 sta $f3
 sta $d015
 lda $70
 sta $f0
 sta $d012
 lda $71
 sta $f1
E_b1b9 sta $d013
 lda #$80
 sta $8c
 ldy $80
 cpy $ad
 beq E_b1cf
 ldx $0200,y
 beq E_b1cf
 cpx #$08
 bcc E_b1ea
E_b1cf pla
 sta $8b
 ldx #$05
E_b1d4 lda $ad,x
 sta $80,x
 dex
 bpl E_b1d4
 inx
 stx $aa
 jsr E_b333
 jsr E_a5a3
 jsr E_a5d8
 jmp E_a686
E_b1ea inc $83
 lda $87
 :$02 lsr @
 ora $86
 sta $91
 lda #$0f
 pha
 dey
 lda $0200,y
 beq E_b201
 pla
 ora #$40
 pha
E_b201 iny
 iny
 lda $0200,y
 beq E_b20c
 pla
 ora #$80
 pha
E_b20c tya
 sec
 sbc #$15
 tay
 lda $0200,y
 beq E_b21a
 pla
 ora #$20
 pha
E_b21a tya
 clc
 adc #$28
 tay
 lda $0200,y
 beq E_b228
 pla
 ora #$10
 pha
E_b228 pla
 dex
 ora E_b26b,x
 ora $91
 cmp #$ff
 beq E_b1cf
 ldx #$03
E_b235 cmp E_b26b,x
 beq E_b24e
 dex
 bpl E_b235
E_b23d jsr E_a99e
 bne E_b263
 lda $80
 clc
 adc E_af81,x
 tay
 lda $0200,y
 bne E_b23d
E_b24e stx $85
 jsr E_aa00
 bcs E_b23d
 jsr E_a6d3
 ldx $80
 lda $0200,x
 cmp #$05
 bcc E_b268
 bcs E_b23d
E_b263 jsr ReadKey
 bcc E_b23d
E_b268 jmp E_b072

E_b26b dta b($bf,$7f,$ef,$df,$3f,$cf,$00)

E_b333 lda $85
 ldx $8b
 bpl E_b33b
 lda $b2
E_b33b asl @
 tax
 lda AdrSprite,x
 sta $a0
 lda AdrSprite+1,x
 sta $a1
 rts
E_b348 txa
 clc
 adc #$0f
 tax
E_b34d lda ($a0),y
E_b34f sta pmg+$400+2,x
 iny
 lda ($a0),y
E_b355 sta pmg+$500+2,x
 iny
 dex
 cpy #$20
 bcc E_b34d
 rts
E_b35f ldx $84
E_b361 ldy #$14
 lda #$00
E_b365 sta pmg+$600,x
 sta pmg+$700,x
 sta pmg+$300,x
 inx
 dey
 bne E_b365
 rts
E_b373 ldx $84
 ldy #$02
E_b377 lda E_b28a,y
 and #$c0
 sta pmg+$400,x
 lda E_b272,y
 and #$c0
 sta pmg+$500,x
 lda E_b290,y
 and #$c0
 sta pmg+$400+$10,x
 lda E_b282,y
 and #$c0
 sta pmg+$500+$10,x
 lda E_b2a2,y
 sta pmg+$300,x
 lda E_b2b2,y
 sta pmg+$300+$10,x
 inx
 iny
 cpy #$06
 bcc E_b377
 :$02 jsr E_afd6
 sty $91
 lda #$11
 sta $92
 lda #$e0
 sta $a5
 lda #$c3
 sta $a6
E_b3bd ldx $84
 ldy #$02
E_b3c1 lda E_b28a,y
 and $a6
 sta pmg+$400,x
 lda E_b272,y
 and $a6
 sta pmg+$500,x
 lda E_b29a,y
 and $a5
 sta pmg+$400+$10,x
 lda E_b282,y
 and $a5
 sta pmg+$500+$10,x
 inx
 iny
 cpy #$06
 bcc E_b3c1
 sec
 ror $a5
 sec
 rol $a6
 lda $a6
 ora #$c0
 sta $a6
 lda $91
 tay
 clc
 adc $84
 tax
 jsr E_b416
E_b3fd sty $91
 lda $92
 tay
 clc
 adc $84
 tax
 jsr E_e340
 sty $92
 :$02 jsr E_afd6
 cpy #$05
 bne E_b3bd
 rts
E_b416 jsr E_b419
E_b419 lda E_b28a,y
 sta pmg+$300+$fe,x
 lda E_b272,y
 sta pmg+$400+$fe,x
 inx
 iny
 rts

;--
; icl 'plaympt.asm'
 
; czwarte tlo 
;	org $b480
	
;tlo03
;	ins 'tlo03.dat'

jasno lda $d20a
 and #$f0
 jsr setCol
 mwa #colMax tabColMax+1
 lda #1
 sta ColADD+1

DawajLogoMentala ldx #$f
cLop2__ jsr wait
 ldy #3
cLop2 lda $f4,y
 and #$0f
tabColMax cmp colMax,y
 beq cQ2
 lda $f4,y
 clc
colADD adc #1
 sta $f4,y
cQ2 dey
 bpl cLop2
 dex
 bne cLop2__
 jsr wait
 rts
colMax dta b(4,8,$c,$e)

ciemno ldy #$f
cLop__ jsr wait
; jsr wait
 ldx #3
cLop lda $f4,x
 and #$0f
 beq cQ
 dec $f4,x
cQ dex
 bpl cLop
 dey
 bne cLop__

 jsr wait
setZero lda #0
setCol ldy #3
nulCol sta $f4,y
 dey
 bpl nulCol
 jsr wait
 rts
 
;-----------
;-
;- CREDITSY
Napisy
;$e437, napisy poczatkowe, 4 ekrany

 dta b($0a+4,$1c,$03,$0f,$04,$05,$1c,$fe)	;code
; dta b(0,$fe)				;z  u   k   o   w   s   k   i 
 dta b($06,$04,$01,$0e,$76,$05,$0c,$00,$1a,$14,$0b,$0f,$16,$12,$0b,$76,$fe)	;daniel zukowski
;           d   a   n   i   e   l
;-         t  o  m  a  s   z    b
 dta b($09,19,$f,$d,1,$12,$18,0,2,$76,5,$c,1,$fe)	;tomasz biela
 dta b(10,$10,1,$16,5,$19,0,$e,$f,$16,1,$b,$ff)		;pawel nowak - memory setup
 
 dta b($0c-2,$1c,$07,$11,$01,$10,$08,$76,$03,$12,$1c,$fe)	;graphics
 dta b($08,$12,$19,1,$16,5,$b,$00,$12,$c,5,4,$18,$fe)		;slawek sledz - Slaves
 dta b($05,$d,$76,3,8,1,$19,$00,7,1,$11,2,1,3,$76,1,$b,$fe)	;michal garbaciak
 dta b($06,$b,1,$d,$76,$c,0,$16,1,$c,1,$12,$18,5,$b,$ff)	;kamil walaszek - Vidol

 dta b($0f-2,$1c,$0d,$14,$12,$76,$03,$1c,$fe)	;music
; dta b(0,$fe)
; dta b($0a,$0a,$0f,$05,$00,$11,$76,$10,$10,$05,$11,$ff)	;joe ripper
; dta b($05,$d,1,$11,5,$b,0,2,1,4,$b,$f,$16,$12,$b,$76,$fe+1)	;marek badkowski
 dta b($04,$19,$14,$b,1,$12,$18,$00,$12,$17,3,8,$f,$16,$76,3,$18,$fe)	;lukasz sychowicz
 dta b($08,$12,$19,1,$16,5,$b,$00,$12,$c,5,4,$18,$ff)
 
;- hit trigger ...
 dta b($00,$fe,$02,$08,$76,$13)
 dta b($00,$13,$11,$76,$07,$07,$05,$11,$00,$13,$0f,$00,$10,$0c,$01,$17)
 dta b($fe,$06,$0f,$11,$00,$74,$11,$05,$13,$14,$11,$0e,$74,$00,$13,$0f)
 dta b($fe,$05,$05,$0e,$13,$05,$11,$00,$10,$01,$12,$12,$16,$0f,$11,$04)
 dta b($ff)

;- jedyne wlasciwe haslo
;- DANEK
TstPass dta b($04,$01,$0e,$05,$0b,$1b)

;- Napis pokazujacy numer Levelu i odpowiadajacy mu password
;- LEVEL xy
;- PASSWORD_'xxxxxx'
;$e551
Level dta b($0c,$0c,$05,$15,$05,$0c,$00,$1c,$1d,$fe)
 dta b($00,$fe)
 dta b($04,$10,$01,$12,$12,$16,$0f,$11,$04,$00,$74)
PutPass dta b($00,$00,$00,$00,$00,$00)
 dta b($74,$ff)
 

;- napis ENTER PASSWORD
;- dta b(ile_spacji,text)
;- $fe = EOL koniec linii
;- $ff = koniec calego txtu
;- $00 = spacja
;- $01 = A
;- $05 = E
;- $06 = F ...
;- $76 = I znak specjalny, ma szerokosc 1
;-
EnterPassword dta b(0,$fe)
 dta b($06,$05,$0e,$13,$05,$11)	;$e58a, 6spacji'ENTER'
 dta b($00,$10,$01,$12,$12,$16,$0f,$11,$04)	;'_PASSWORD'
 dta b($fe)					;koniec linii
 
 dta b($e)					;14 spacji
pass dta b($00,$00,$00,$00,$00,$00)		;6 znakow hasla 
 dta b($ff)					;koniec txtu

Alfabet dta b($3f,$15,$12,$3a,$2a,$38,$3d,$39)	;$e5a2, alfabet akceptowanych liter (24 znaki)
 dta b($0d,$01,$05,$00,$25,$23,$08,$0a)
 dta b($28,$3e,$2d,$0b,$10,$2e,$2b,$17)

;---

Mnoz ldy #0
 sty $97
; :$05 asl @		;mnoz x 32
mn asl @
 dex
 bne mn
 rol $97
 clc
lcyf adc <Cyfry
 sta $96
 lda $97
hcyf adc >Cyfry
 sta $97
 rts

E_e4fa jsr ShowTxt	;pokazanie numery Levelu
E_e4fd lda #$00		;czekanie na naciscniecie Fire lub Space
 sta $f6
 sta $f5
 jsr ClrSprite
 sta k709+1
 lda >FntBW
 sta FntBase+1		;ustaw fonty
 lda #$31
 sta gtia+1		;ustaw sprity

 lda <dli2
 sta dli_LMS+1
; sta DliVec+1
 lda >dli2
 sta dli_MSB+1
; sta DliVec+2

 mwa #ant2 $d402 
* lda #$70
* sta $d402
* lda #$e5
* sta $d403
  
 jsr Wait
 lda #$22
 sta dmactl+1
 ldx #$0f
E_e52b jsr Wait
 inc $f5
 dex
 bne E_e52b

 ldx #$0f
fad inc k709+1	;rozjasniamy
 jsr Wait
 dex
 bne fad
 rts

;----
 
MoveCyf stx ofs+1	;subroutine
 sta rA+1
 ldy <Cyfry
 sty lcyf+1
 ldy >Cyfry
 sty hcyf+1
 ldx #5
 jsr mnoz
ofs ldx #0
 ldy #$1f
E_e4f0 lda ($96),y
 sta FntBW+$360,x	;modyfikuje zestaw znakow FntBw, wprowadzajac cyfry dla napisu LEVEL
 dex
 dey
 bpl E_e4f0
 
 ldy <Cyfry2
 sty lcyf+1
 ldy >Cyfry2
 sty hcyf+1
 ldx #4
rA lda #0
 jsr mnoz
 ldx ofs+1
 ldy #$0f
mv00 lda ($96),y
 sta FntBW2+$360-16,x
 dex
 dey
 bpl mv00
 rts

;---
PokazLogoMentala

 mwa #MentalKolor TabColMax+1
 lda #2
 sta ColADD+1

; lda #$f
; sta kol+1
 ldx #8
wygas_2 ldy #0
wygas2 lda kol01+1,y
 cmp TMaxKolor+1,y
 beq nxt2

 and #$0f
 add #2
 ora #clog2
 sta kol01+1,y
nxt2 jsr Wait
 tya
 add #5
 tay
 cpy #20
 bne wygas2
 dex
 bne wygas_2

TMaxKolor lda #clog2+6
 sta kol01+1
 lda #clog2+8
 sta kol01+1+5
 lda #clog2+$c
 sta kol01+1+10
 lda #clog2+$e
 sta kol01+1+15

 ldy #3
 lda #clog1
po sta $f4,y
 dey
 bpl po
 jsr DawajLogoMentala

 lda #clog1+6		;kolory spod $f0 sa przepisywane do $d016...
 sta $f4
 lda #clog1+8
 sta $f5
 lda #clog1+$c
 sta $f6
 lda #clog1+$e
 sta $f7

 mwa #Petla Petla+1
 jmp Petla

;---=
 org $5800
;---=
BarInt
 ins 'fnt\oko1.fnt'
 ins 'fnt\oko2.fnt',0,1664

;-----------
; org $d800
;-----------

;- 16 klockow, kazdy po 32bajty, 16*32=512
klocki ins 'dat\klocki.dat'	;$dc40

;- 8 faz ruchu na kazdy kierunek (256 bajtow)
;- 1 faza = 32 bajty, po 16 dla kazdego sprita, sprity 4kolorowe
;- faza pion-gora i pion-dol sa takie same, tylko odwrocone
;- $de40-$df3f ruch w prawo
;- $df40-$e03f ruch w pionie
;- $e040-$e13f ruch w lewo
Duch   ins 'dat\duch.dat'		;$de40-$e13f

;- 7 faz wybuchu klocka
Wybuch ins 'dat\wybuch.dat'

 
;- 3 klocki, 96bajtow
NewKlocek
 dta b($94,$90,$40,$40,$01,$00,$41,$06,$5a,$06,$01,$41,$91,$40,$01,$40)		;$e2c0
 dta b($41,$40,$40,$00,$40,$40,$90,$a6,$00,$01,$10,$64,$11,$01,$06,$56)
 dta b($6f,$b5,$e4,$d0,$c0,$40,$c0,$c0,$f9,$5e,$1b,$07,$02,$01,$02,$03)
 dta b($c0,$c0,$c0,$d0,$e6,$fb,$a6,$51,$02,$01,$03,$07,$9b,$ef,$9a,$45)
 dta b($6f,$b5,$e5,$d5,$d5,$55,$d5,$d5,$f9,$5e,$57,$57,$56,$55,$56,$57)
 dta b($d5,$d5,$d5,$d5,$e6,$fb,$aa,$51,$56,$55,$57,$57,$9b,$ef,$aa,$45)
 dta b($be,$be,$df,$df,$f7,$f6,$fd,$fd,$ed,$b9,$a4,$a5,$e4,$d5,$54,$51)		;$e320
 dta b($b9,$ee,$b6,$d9,$96,$d9,$65,$99,$44,$51,$90,$94,$54,$94,$55,$55)

MentalKolor dta b(6,8,$c,$e)

;- Napis po skonczeniu wszystkich poziomow
;- FINALLY_YOU_REACHED
;- THE_END
;- UNFORTUNATELY
;- HERE_IS_NOTHING_BUT
;- CONGRATULATIONS
YouWin dta b($01,$06,$76,$0e,$01,$0c,$0c,$17,$00,$17,$0f,$14,$00,$11,$05,$01,$03,$08,$05,$04,$fe)
 dta b($0d,$13,$08,$05,$00,$05,$0e,$04,$fe)
 dta b($07,$14,$0e,$06,$0f,$11,$13,$14,$0e,$01,$13,$05,$0c,$17,$fe)
 dta b($01,$08,$05,$11,$05,$00,$76,$12,$00,$0e,$0f,$13,$08,$09,$0e,$07,$00,$02,$14,$13,$fe)
 dta b($05,$03,$0f,$0e,$07,$11,$01,$13,$14,$0c,$01,$13,$76,$0f,$0e,$12,$ff)
;---

FadeOut stx $96		;wygas logosy MENTAL AGE
 sty $97
 sta kol+1
 ldx #8
wygas_ ldy #0
wygas lda ($96),y
 and #$0f
 beq Zero
 sub #2
kol ora #$30
 sta ($96),y
nxt jsr Wait
 tya
 clc
 adc #5
 tay
 cpy #20
 bne wygas
 dex
 bne wygas_
 rts
Zero lda #0
 sta ($96),y
 beq nxt
;---
 
E_e534 ldy #$0f
E_e536 jsr E_e34c
 dey
 bne E_e536
 rts

;----

E_e53d tax	;dodajemy
 clc
 adc $96
 sta $96
 lda $a5
 adc $97
 sta $97
 txa
 rts

;------------

PanelOff lda Cbar0+1		;wygas panel
 and #$f
 beq e_0
 dec Cbar0+1
 bne e_0_
e_0 sta Cbar0+1
e_0_ lda Cbar1+1
 and #$f
 beq e_1
 dec Cbar1+1
 bne e_1_
e_1 sta Cbar1+1
e_1_ lda Cbar2+1
 and #$f
 beq e_2
 dec Cbar2+1
 bne e_2_
e_2 sta Cbar2+1
e_2_ lda Cbar3+1
 and #$f
 beq e_3
 dec Cbar3+1
 bne e_3_
e_3 sta Cbar3+1

e_3_ ldx #39		;tutaj tez tylko rejestr X
t_3 lda tecza,x
 and #$f0
 beq t_0
 lda tecza,x
 sub #$10
 sta tecza,x

t_0 lda tecza,x
 and #$0f
 beq t_1
 lda tecza,x
 sub #$01
 sta tecza,x

t_1 dex
 bpl t_3
 rts

;---

setTecza ldx #39	;tutaj tylko rejestr X
 lda tecza_tmp,x
 sta tecza,x
 dex
 bpl setTecza+2
 rts

TECZA_tmp dta b($11,$11,$22,$22,$33,$33,$44,$45,$55,$66,$67,$77,$88,$99,$aa,$bb)
 dta b($cc,$dd,$ee,$ff,$ff,$ee,$dd,$cc,$bb,$aa,$99,$88,$77,$76,$66,$55)
 dta b($54,$44,$33,$33,$22,$22,$11,$11)
 
;------------

WyciszMsx ldy #15
w_3 jsr wait
 jsr wait
 jsr wait
 jsr wait

 ldx #15
w_2 lda cisza,x
 beq w_1
 sub #1
 sta cisza,x
w_1 dex
 bpl w_2
 dey
 bpl w_3
 jmp msxStop


SetMsx lda #$4c
 sta mpt

 ldy #15
q_3 jsr wait
 jsr wait
 jsr wait
 jsr wait

 ldx #15
q_2 lda cisza,x
 cmp Tmax,x 
 beq q_1
 add #1
 sta cisza,x
q_1 dex
 bpl q_2
 dey
 bpl q_3

; ldy #15	;wyciszamy
;w_0 tya
; sta cisza,y
; dey
; bpl w_0
 rts

Tmax dta b(0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15)
 
 
E_e340 jsr E_e343	;$e340
E_e343 lda E_b2a2,y
 sta $02fe,x
 dex
 dey
 rts
 
E_e34c ldx #$07		;$e34c
E_e34e lda $f0,x
 and #$0f
 bne E_e358
 sta $f0,x
 beq E_e35a
E_e358 dec $f0,x
E_e35a dex
 bpl E_e34e
 jmp Wait

 
ShowTxt jsr Wait		;subroutine	wyswietla napisy
 ldx #$00
 lda #$74	$68
E_e3ca sta scr,x
 sta scr+$100-32,x
 inx
 bne E_e3ca

E_e3d3 lda <scr			;subroutine
 sta $98
 lda >scr
E_e3d9 sta $99
E_e3db jsr E_e42c
 sta $a5
E_e3e0 jsr E_e42c
E_e3e3 cmp #$fe			;jesli koniec linii ($fe)
 bne E_e3f5
 
* lda $98
* clc
* adc #$50
* sta $98
* bcc E_e3f2
* inc $99
 lda #80+40
 add:sta $98
 scc:inc $98+1
 
E_e3f2 jmp E_e3db
E_e3f5 cmp #$ff		;jesli koniec txtu ($ff)
 beq E_e42b
E_e3f9 tax		;jesli =0 czyli spacja
 beq E_e425
 cmp #$74
 bcs E_e404
 dex
 txa
 :$02 asl @
E_e404 tax
 ldy $a5
 sta ($98),y
 jsr PutByteAdd
 cmp #$74		;jesli kod >=$74 to litera ma szerokosc 1 znaku
 bcs E_e412	
 iny
 inx
 txa
 sta ($98),y
 jsr PutByteAdd
E_e412 lda $a5
 clc
 adc #$28
 tay
 inx
 txa
 sta ($98),y
 cmp #$74
 bcs E_e427		;tylko jedna spacja
 iny
 inx
 txa
 sta ($98),y
E_e425 inc $a5		;2x SPACE
E_e427 inc $a5
 bne E_e3e0
E_e42b rts
E_e42c ldy #$00
 lda ($96),y
 inc $96
 bne E_e436
 inc $97
E_e436 rts

PutByteAdd tya
 sty rejY+1
 clc
 adc #80
 tay
 txa
 sta ($98),y
rejY ldy #0
 rts

;mapy komnat
;zapisane po 5bitow na jeden klocek
Komnaty	ins 'dat\komnaty.dat'

;- spakowane zestawy fontow dla logosow
fnt00	ins 'def\fnt00.def'

;- dla game over	
fnt01	ins 'def\fnt01.def'

;-  spakowane fonty Black&White + cyferki 320b + 160b
fnt02	ins 'def\fnt02.def'

;- fonty i screen dla logo - production
fnt03	ins 'def\fnt03.def'

;--------
mpt
 icl 'icl\plaympt.asm'
 
 run start

 opt l-
 icl 'xasm.mac'
